<?php

// QuickTalk 3.0 build:20121228

class cSection extends aQTcontainer implements IMultifield,IDatabase
{

// aQTcontainer includes properties:
// public $uid = -1;   // [int] unique id
// public $pid = -1;   // [int] parent unique id (-1=none) as Domain
// public $class = '0'; // i.e. section: 0=visible, 1=hidden, 2=hidden by user
// public $type = '0';  // Type: "0"=visible, "1"=hidden, "2"=hidden by user
// public $status ='0'; // Status: "0"=actif, "1"=closed
// public $items = 0;  // number of sub items
// public $stats = ''; // list of other stats, can be accessed with IMulitfield interface
// public $error = ''; // can be use to report errors/warnings

public $domname='';         // Domain name
public $idtitle='untitled'; // Section idtitle
public $name='untitled';    // Section name (translation)
public $descr='';           // Section descr (translation)
public $notify=1;           // Notify: 0=disable, 1=enabled
public $modid=0;            // Moderator id
public $modname='Admin';    // Moderaotr name
public $numfield='N';        // Format of the ref number: 'N' means no ref number
public $titlefield=1;       // Topic title: 0=None, 1=Optional, 2=Mandatory
//public $eventdate=0;      // Topic eventdate: 0=None, 1=Optional, 2=Mandatory, 3=Date+time (optional), 4=Date+time (mandatory)
//public $wisheddate=0;     // Topic wisheddate: 0=None, 1=Optional, 2=Mandatory
//public $notifycc=0;       // Topic alternate notify: 0=None, 1=Optional, 2=Mandatory
public $prefix='a';         // Prefix icon from the serie 'a'
public $options='';         // Several options
// computed values
public $lastpostid=-1;
public $lastposttopic=-1;
public $lastpostdate='0';
public $lastpostuser=0;
public $lastpostname='Visitor';
// options
public $d_order=''; // Ticket default sort order
public $d_last='';  // Last column in the topic list: 'none' means no last column
public $d_logo='';  // Ovewrite icon with an image-logo named s_x.gif/.jpeg/.jpg/.png (where x is the section id)

// -- Constructor method (accept an id, an array or a cSection as parameter) --

function cSection($aSection=null,$bLast=false)
{
  if ( isset($aSection) )
  {
    if ( is_int($aSection) )
    {
      if ( $aSection<0 ) die('No section '.$aSection);
      global $oDB;
      $oDB->Query('SELECT f.*,d.title as domtitle FROM '.TABSECTION.' f INNER JOIN '.TABDOMAIN.' d ON d.id=f.domainid WHERE f.id='.$aSection);
      $row = $oDB->Getrow();
      if ( $row===False )  die('No section '.$aSection);
      $this->MakeFromArray($row);
    }
    elseif ( is_array($aSection) )
    {
      $this->MakeFromArray($aSection);
    }
    else
    {
      die('Invalid constructor parameter #1 for the class cSection');
    }
  }

  // Read stats and options

  $this->ReadOptions();

  // Find last post

  if ( $bLast ) $this->GetSectionLastPost($bLast);

  // Default sort order

  if ( $this->d_last=='no' || empty($this->d_last) ) $this->d_last = 'none';
  if ( empty($this->d_order) ) $this->d_order='lastpostdate';
}

// --------

function MakeFromArray($aSection)
{
  foreach($aSection as $strKey=>$oValue) {
  switch ($strKey) {
    case 'domainid':
    case 'pid':          $this->pid     = (int)$oValue; break;
    case 'id':
    case 'uid':          $this->uid       = (int)$oValue; break;
    case 'title':        $this->idtitle   = $oValue; break;
    case 'type':         $this->type      = (int)$oValue; break;
    case 'status':       $this->status    = (int)$oValue; break;
    case 'options':      $this->options   = $oValue; break;
    case 'notify':       $this->notify    = (int)$oValue; break;
    case 'moderator':    $this->modid     = (int)$oValue; break;
    case 'moderatorname':$this->modname   = $oValue; break;
    case 'numfield':     $this->numfield  = $oValue; break;
    case 'titlefield':   $this->titlefield= (int)$oValue; break;
    //case 'eventdate':    $this->eventdate = (int)$oValue; break;
    //case 'wisheddate':   $this->wisheddate= (int)$oValue; break;
    //case 'alternate':    $this->notifycc  = (int)$oValue; break;
    case 'prefix':       $this->prefix    = $oValue; break;
  }}
  $this->name = ObjTrans('sec','s'.$this->uid,$this->idtitle);
  $this->descr = ObjTrans('secdesc','s'.$this->uid,false);
  $this->domname= ObjTrans('domain','d'.$this->pid,'(domain '.$this->pid.')');
}

// --- [i] ---

public static function Add($intDom=0,$str='untitled')
{
  QTargs( 'cSection->Add',array($intDom,$str),array('int','str') );
  if ( empty($str) ) die('cSection->Add: Argument #1 must be a string');

  // Inserts a new section

  global $oDB;
  $oDB->Query( 'INSERT INTO '.TABSECTION.' (domainid,id,type,status,notify,titleorder,moderator,titlefield,title,stats,options,moderatorname,numfield,prefix) VALUES ('.$intDom.','.$oDB->Nextid(TABSECTION).',0,0,1,0,0,1,"'.addslashes($str).'","","coord=0;order=0;last=0;logo=0","Admin","N","a")' );

  // Impact on globals

  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
}

// ----------

public static function Delete($id=-1)
{
  if ( !is_int($id) || $id<0 ) die('cSection->Delete: Argument #1 must be an integer'); // section 0 cannot be deleted

  // Process

  global $oDB;
  cSection::DeleteItems($id);
  $oDB->Query('DELETE FROM '.TABSECTION.' WHERE id='.$id);
  cLang::Delete(array('sec','secdesc'),'s'.$id);

  // Impact on globals

  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  if ( isset($_SESSION['L']['sec'][$id]) ) Unset($_SESSION['L']['sec'][$id]);
  if ( isset($_SESSION['L']['secdesc'][$id]) ) Unset($_SESSION['L']['secdesc'][$id]);
}

// --------

public function GetLogo()
{
  if ( !empty($this->d_logo) )
  {
  if ( file_exists('upload/section/'.$this->d_logo) ) return 'upload/section/'.$this->d_logo;
  }
  return $_SESSION[QT]['skin_dir'].'/ico_section_'.$this->type.'_'.$this->status.'.gif';
}

// --------

public function GetSectionLastPost($intLast)
{
  // Initialize

  $this->lastpostid = null;
  $this->lastposttopic = null;
  $this->lastpostdate = null;
  $this->lastpostuser = null;
  $this->lastpostname = null;

  // Check

  if ( $this->uid<0 ) return null;

  // Query - attention: Subqueries requires mysql 4.1. We use two queries
  // Search query can be bypassed by providing a $intLast

  global $oDB;

  // Search (maxid)

  if ( is_integer($intLast) )
  {
    $intId = $intLast;
  }
  else
  {
    $oDB->Query( 'SELECT MAX(id) as maxid FROM '.TABPOST.' WHERE forum='.$this->uid );
    $row = $oDB->Getrow();
    $intId = (int)$row['maxid'];
  }

  // Get lastpost informations

  if ( $intId>0 )
  {
    $oDB->Query( 'SELECT id,topic,issuedate,userid,username FROM '.TABPOST.' WHERE id='.$intId );
    if ( $row=$oDB->Getrow() )
    {
    $this->lastpostid = (int)$row['id'];
    $this->lastposttopic = (int)$row['topic'];
    $this->lastpostdate = $row['issuedate'];
    $this->lastpostuser = (int)$row['userid'];
    $this->lastpostname = $row['username'];
    }
  }
}

// --------

public static function GetEachFields($fields="numfield",$bRegister=true)
{
  // for each section, returns an array containing the field settings
  $arr = array();
  global $oDB;
  $oDB->Query( 'SELECT id,'.$fields.' FROM '.TABSECTION );
  $arrFields = explode(',',$fields);
  while($row=$oDB->Getrow())
  {
  $arr[(int)$row['id']] = array();
  foreach($arrFields as $field) $arr[(int)$row['id']][$field] = $row[$field];
  }
  if ( $bRegister ) $_SESSION[QT]['sys_sections_flds'] = $arr;
  return $arr;
}

public static function GetTagsUsed($s=-1,$intMax=20,$strWhere='')
{
  // '*' or -1 to compute on all sections
  // maximum returned is $intMax distinct tags (from most recents active messages)
  // Attention, if defined, $strWhere overwrites $s

  // Check
  if ( $s==='*' ) $s=-1;
  if ( !is_int($s) ) die('cSection->GetTagsUsed: Argument #1 must be integer or "*"');

  // prepare where clause if not provided
  if ( empty($strWhere) ) $strWHere = ' WHERE '.($s<0 ? 't.forum>=0' : 't.forum='.$s);

  // Process

  $arrTags = array();
  global $oDB;
  $oDB->Query( 'SELECT DISTINCT t.tags,t.lastpostdate FROM '.TABTOPIC.' t '.$strWhere.' ORDER BY t.lastpostdate DESC' );
  $i=0;
  while($row=$oDB->Getrow()) {
  if ( !empty($row['tags']) ) {

    $arr = explode(';',$row['tags']);
    foreach($arr as $str)
    {
      if ( !empty($str) ) {
      if ( !in_array($str,$arrTags) ) {
        $arrTags[$str] = $str;
        $i++;
        if ( $i>$intMax ) break;
      }}
    }
    if ( $i>$intMax ) break;

  }}
  if ( count($arrTags)>2 ) asort($arrTags);
  return $arrTags;
}

// --------

public static function MoveItems($id,$dest,$item=-1,$bClosedOnly=false,$strYear='',$intRenum=1,$prefix='')
{
  if ( !is_int($id) ) die('cSection->MoveItems: Argument #1 must be integer'); // section
  if ( !is_int($dest) ) die('cSection->MoveItems: Argument #2 must be integer'); // destination section
  if ( $id<0 ) die('cSection->MoveItems: Wrong argument #1 (id<0)');
  if ( $dest<0 ) die('cSection->MoveItems: Wrong argument #2 (d<1)');
  if ( $id==$dest ) die('cSection->MoveItems: Wrong argument, source=destination');
  if ( !is_string($strYear) ) $strYear = (int)$strYear; // $strYear can be a integer or "old"
  if ( strlen($strYear)>4 ) die('cSection->MoveItems: Argument #2 must be a string');

  global $oDB;
  $strWhere = (empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));
  $strTopic = '';
  $strPost = '';
  $strField = ''; if ( $intRenum===0 ) $strField = ', numid = 0';

  // Move only one topic

  if ( $item>=0 )
  {
    $strTopic=" AND id=$item";
    $strPost=" AND topic=$item";
    if ( $intRenum==2 )
    {
    $nextnumid = $oDB->Nextid(TABTOPIC,'numid','WHERE forum='.$dest);
    $strField = ', numid='.(int)$nextnumid;
    }
    $bClosedOnly=false;
  }
  else
  {
    if ( $intRenum==2 )
    {
    $nextnumid = $oDB->Nextid(TABTOPIC,'numid','WHERE forum='.$dest);
    $oDB->Query('SELECT MIN(numid) as minnumid FROM '.TABTOPIC.' WHERE forum='.$id);
    $row = $oDB->Getrow();
    $minnumid = $row['minnumid'];
    $strField = ", numid = $nextnumid + (numid - $minnumid)";
    }
  }

  // Check if prefix system are the same. If not, remove the prefix.

  $strSetPrefix = '';
  if ( !empty($prefix) )
  {
    $oDB->Query('SELECT prefix FROM '.TABSECTION.' WHERE id='.$dest);
    $row = $oDB->Getrow();
    if ( $row['prefix']!=$prefix ) $strSetPrefix = ',icon="00"';
  }

  // Update topics and posts

  if ( $bClosedOnly )
  {
    $arr = array();
    $oDB->Query('SELECT id FROM '.TABTOPIC.' WHERE forum='.$id.' AND status="1" AND type="T"'.$strWhere);
    while($row=$oDB->Getrow()) $arr[] = (int)$row['id'];
    foreach($arr as $intVal)
    {
    $oDB->Query( 'UPDATE '.TABTOPIC.' SET forum='.$dest.$strField.',modifdate="'.date('Ymd His').'" WHERE id='.$intVal );
    $oDB->Query( 'UPDATE '.TABPOST.' SET forum='.$dest.$strSetPrefix.' WHERE topic='.$intVal );
    }
  }
  else
  {
    $oDB->Query( 'UPDATE '.TABTOPIC.' SET forum='.$dest.$strField.',modifdate="'.date('Ymd His').'" WHERE forum='.$id.$strTopic.$strWhere );
    $oDB->Query( 'UPDATE '.TABPOST.' SET forum='.$dest.$strSetPrefix.' WHERE forum='.$id.$strPost.str_replace('firstpostdate','issuedate',$strWhere) );
  }
}

// --------

public static function DeleteItems($id,$bClosedOnly=false,$strYear='')
{
  if ( !is_int($id) ) die('cSection->DeleteItems: Argument #1 must be integer'); // section
  if ( $id<0 ) die('cSection->DeleteItems: Wrong argument #1 (id<0)');
  if ( !is_string($strYear) ) $strYear = (int)$strYear; // $strYear can be a integer or the string 'old'
  if ( strlen($strYear)>4 ) die('cSection->DeleteItems: Argument #2 must be a string');

  global $oDB;
  $strWhere = ($bClosedOnly ? ' AND status="1"' : '').(empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));

  if ( $bClosedOnly )
  {
    $arr = array();
    $oDB->Query( 'SELECT id FROM '.TABTOPIC.' WHERE forum='.$id.' AND type="T"'.$strWhere );
    while($row=$oDB->Getrow()) $arr[]=$row['id'];
    foreach($arr as $id)
    {
      $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic='.$id );
      $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id='.$id );
    }
  }
  else
  {
    $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE forum='.$id.str_replace('firstpostdate','issuedate',$strWhere) );
    $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE forum='.$id.$strWhere );
  }

  // Impact on globals

  if ( isset($_SESSION[QT]['sys_stat_items']) ) Unset($_SESSION[QT]['sys_stat_items']);
  if ( isset($_SESSION[QT]['sys_stat_itemsZ']) ) Unset($_SESSION[QT]['sys_stat_itemsZ']);
  if ( isset($_SESSION[QT]['sys_stat_replies']) ) Unset($_SESSION[QT]['sys_stat_replies']);
  if ( isset($_SESSION[QT]['sys_stat_repliesZ']) ) Unset($_SESSION[QT]['sys_stat_repliesZ']);
}

// --------

public static function CountItems($id,$q,$intD=10,$strYear='',$strWhere='')
{
  if ( $id==='*' ) { $id='forum>=0'; } else { $id='forum='.$id; }
  if ( !is_string($q) ) die('cSection::CountItems: Wrong argument (q)');
  if ( !is_string($strWhere) ) die('cSection::CountItems: Wrong argument (where)');

  if ( !is_int($intD) ) die('cSection::Count: Argument #2 must be an int');
  if ( $intD<1 ) die('cSection::CountItems: Wrong argument #2 (d<1)');
  if ( !is_string($strYear) ) $strYear = (int)$strYear; // $strYear can be a integer or "old"
  if ( strlen($strYear)>4 ) die('cSection::CountItems: Argument #3 must be a string');

  global $oDB;

  $strWhere .= (empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));

  // Process

  switch($q)
  {
  case 'items':
  case 'topics': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE '.$id.$strWhere ); break;
  case 'itemsZ':
  case 'topicsZ': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE status="1" AND '.$id.$strWhere ); break;
  case 'news': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE '.$id.' AND type="A"'.$strWhere ); break;
  case 'replies': $oDB->Query( 'SELECT count(*) as countid FROM '.TABPOST.' WHERE '.$id.' AND (type="R" OR type="F")'.str_replace('firstpostdate','issuedate',$strWhere) ); break;
  case 'repliesZ': $oDB->Query( 'SELECT count(*) as countid FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id WHERE p.'.$id.' AND p.type<>"P" AND t.status="1"'.$strWhere ); break;
  case 'unreplied': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE '.$id.' AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  case 'unrepliedT': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE '.$id.' AND type="T" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  case 'unrepliedA': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE '.$id.' AND type="A" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  case 'tags': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE tags<>"" AND '.$id.$strWhere ); break;
  case 'messages': $oDB->Query( 'SELECT count(*) as countid FROM '.TABPOST.' WHERE '.$id.$strWhere ); break;
  case 'unrepliednews': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE '.$id.' AND type="A" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break; // (unrepliedA) stays for backbward compatibility
  default: die('cSection::CountItems: Wrong argument (q) '.$q);
  }
  $row = $oDB->Getrow();
  return (int)$row['countid'];
}

// --------

public function ReadOptions()
{
  $arr = QTexplode($this->options);
  if ( isset($arr['order']) ) $this->d_order = $arr['order'];
  if ( isset($arr['last']) ) $this->d_last = $arr['last'];
  if ( isset($arr['logo']) ) $this->d_logo = $arr['logo'];
}
public function SaveOptions($arr)
{
  if ( !is_array($arr) ) die('SaveOptions: argument #1 must be an array');
  $this->options = QTimplode($arr);
  global $oDB;
  $oDB->Query('UPDATE '.TABSECTION.' SET options="'.$this->options.'" WHERE id='.$this->uid);
  $this->ReadOptions(); // Refresh
}
public function UpdateLastPostDate()
{
  global $oDB;
  if ( in_array($oDB->type,array('sqlite','sqlsrv','mssql','pg','db2')) )
  {
  $oDB->Query( 'UPDATE '.TABTOPIC.' SET lastpostdate=(SELECT MAX(issuedate) FROM '.TABPOST.' p, '.TABTOPIC.' t WHERE t.id=p.topic) WHERE forum='.$this->uid );
  }
  else
  {
  $oDB->Query( 'UPDATE '.TABTOPIC.' t SET t.lastpostdate=(SELECT MAX(p.issuedate) FROM '.TABPOST.' p WHERE t.id=p.topic) WHERE t.forum='.$this->uid );
  }
}
public function UpdateReplies()
{
  global $oDB;
  if ( in_array($oDB->type,array('sqlite','sqlsrv','mssql','pg','db2')) )
  {
  $oDB->Query( 'UPDATE '.TABTOPIC.' SET replies=(SELECT COUNT(*) FROM '.TABPOST.' p, '.TABTOPIC.' t WHERE t.id=p.topic) WHERE forum='.$this->uid );
  }
  else
  {
  $oDB->Query( 'UPDATE '.TABTOPIC.' t SET t.replies=(SELECT COUNT(p.id) FROM '.TABPOST.' p WHERE t.id=p.topic AND p.type<>"P") WHERE t.forum='.$this->uid );
  }
}

// --------
// IMultifield, IDatabase implementations
// --------

public function MRead($prop,$bAssign=true,$prefix='')
{
  // @prop    Reads the property and split it in an array
  // @bAssign If array keys are properties, the values are assigned to these properties
  // @prefix  Destination properties can have a prefix
  if ( !isset($this->$prop) ) die('cSection::MRead: Undefined propertie ['.$prop.']');
  $arr = QTexplode($this->$prop);
  if ( $bAssign )
  {
    foreach($arr as $key=>$value)
    {
    $key = $prefix.$key;
    if ( isset($this->$key) ) $this->$key=$value;
    }
  }
  return $arr;
}

public function MGet($prop,$key,$na='')
{
  // Returns an option value (or $strNA if key not found)
  if ( !isset($this->$prop) ) die('cSection::MGet: Undefined propertie ['.$prop.']');
  QTargs('cSection->MGet',array($key,$na));
  if ( empty($key) ) die('cSection::MGet: Missing key');

  $arr = QTexplode($this->$prop);
  if ( isset($arr[$key]) ) return $arr[$key];
  return $na;
}

public function MChange($prop,$key,$value='')
{
  QTargs('cSection->MChange',array($prop,$key));
  if ( !isset($this->$prop) ) die('cSection::MChange: Undefined propertie ['.$prop.']');
  if ( empty($key) ) die('cSection::MChange: Missing key');

  $arr = QTarradd(QTexplode($this->$prop),$key,$value);
  $this->$prop = QTimplode($arr);
  $this->UpdateField($prop,$this->$prop);
  return $arr;
}

public static function GetTable() { return TABSECTION; }
public static function GetFields($type='')
{
  switch($type)
  {
  case 'int': return array('id','pid','status','titleorder','moderator'); break;
  case 'str': return array('type','notify','title','moderatorname','stats','options','numfield','titlefield','wisheddate','alternate','prefix'); break;
  }
  return array('id','section','pid','userid','status','pclass','textmsg','username','issuedate','attach');
}

public static function GetSqlValue($strField,$strValue)
{
  if ( in_array($strField,cSection::GetFields('int')) ) return ($strValue==='' || is_null($strValue) ? 'NULL' : $strValue);
  if ( empty($strValue) ) if ( in_array($strField,cSection::GetFields('str')) ) return '"0"';
  return '"'.$strValue.'"';
}

public function UpdateField($strField,$strValue)
{
  if ( !is_string($strField) ) die('cSection::UpdateField: Invalid field ['.$strField.']');
  global $oDB;
  return $oDB->Query( 'UPDATE '.cSection::GetTable().' SET '.$strField.'='.$this->GetSqlValue($strField,$strValue).' WHERE id='.$this->uid );
}

public function Insert() {}

// --------


}