<?php

// QuickTalk 3.0 build:20121228

// ==========
// VIP means Visitor In Page: This class includes info on the current user and the current page,
// The class also provides major lists or global stats used in most of the pages
// ==========

class cVIP extends cSYS
{
  public $team_id;
  public $team_name;

  public $domains = array(); // list of domains (translated) visible for the current user ($oVIP->user->role)
  public $sections = array();// list of sectionstitles (translated) visible for the current user ($oVIP->user->role)
  public $statuses = array();// list of statuses

  public $items = 0;         // count items
  public $itemsZ = 0;        // count items inactive
  public $replies = 0;         // count notes
  public $repliesZ = 0;        // count notes (only the in-process notes)
  public $members = 0;       // count members
  public $states = array();  // other info

  // --------

  function __construct()
  {
    parent::__construct(); // call cSYS constructor

    // initialise list of domains, sections, status (depend on user role)
    if ( !isset($_SESSION[QT]['sys_domains']) ) $_SESSION[QT]['sys_domains'] = GetDomains($this->user->role);
    if ( !isset($_SESSION[QT]['sys_sections']) ) { $_SESSION[QT]['sys_sections'] = QTarrget(GetSections($this->user->role)); }
    $this->domains = $_SESSION[QT]['sys_domains'];
    $this->sections = $_SESSION[QT]['sys_sections'];

    // stats initialisation (if not yet done)
    if ( !isset($_SESSION[QT]['sys_stat_items']) ) $this->stats->items = cSection::CountItems('*','items');
    if ( !isset($_SESSION[QT]['sys_stat_itemsZ']) ) $this->stats->itemsZ = cSection::CountItems('*','itemsZ');
    if ( !isset($_SESSION[QT]['sys_stat_replies']) ) $this->stats->replies = cSection::CountItems('*','replies');
    if ( !isset($_SESSION[QT]['sys_stat_repliesZ']) ) $this->stats->repliesZ = cSection::CountItems('*','repliesZ');
    if ( !isset($_SESSION[QT]['sys_stat_members']) ) $this->stats->members = cVIP::SysCount('members');
    if ( !isset($_SESSION[QT]['sys_stat_states']) ) $this->stats->states = cVIP::SysCount('states');

    // login check
    if ( $this->user->auth )
    {
      if ( isset($_SESSION[QT.'_usr_team_id']) ) $this->team_id = (int)$_SESSION[QT.'_usr_team_id'];
      if ( isset($_SESSION[QT.'_usr_team_name']) ) $this->team_name = $_SESSION[QT.'_usr_team_name'];
    }

    // Web/Team Login

    if ( !$this->user->auth && isset($_SESSION[QT]['login_qte_web']) && !empty($_SESSION[QT]['login_qte_web']) ) $this->LoginTeam('qte');
    if ( !$this->user->auth && isset($_SESSION[QT]['login_qte']) && !empty($_SESSION[QT]['login_qte']) ) $this->LoginTeam($_SESSION[QT]['login_qte']);

  }

  // -------- old methods, now handled by subclasses in cSYS

  function CanView($strCanView='V5',$bStopOff=true) { return $this->user->CanView($strCanView,$bStopOff); }
  function IsPrivate($str,$id) { return $this->user->IsPrivate($str,$id); }
  function IsStaff() { return $this->user->IsStaff(); }
  function Login($username='',$password='',$bRemember=FALSE) { return $this->user->Login($username,$password,$bRemember); }

// --------

public static function GetCoppa($id)
{
  if ( !is_int($id) || $id<0 ) die('cVIP->GetCoppa: Invalid argument');
  // No need to add query: coppa values are available in the $_SESSION[QT.'_usr_info']
  $children = cUser::GetUserInfo('children',0);
  $parentmail = cUser::GetUserInfo('parentmail',0);
  return array('children'=>(int)$children,'parentmail'=>$parentmail);
}

// --------
// DOLOGINTEAM check weblogin/teamlogin

function LoginTeam($sid='qte')
{
  if ( isset($_SESSION[$sid.'_usr_auth']) && ( isset($_SESSION[$sid.'_usr_name']) || isset($_SESSION[$sid.'_usr_username']) ) ) {
  if ( $_SESSION[$sid.'_usr_auth'] ) {

    global $oDB;

    // check coherence: name must exist
    if ( isset($_SESSION[$sid.'_usr_name']) ) { $str = $_SESSION[$sid.'_usr_name']; } else { $str=$_SESSION[$sid.'_usr_username']; }
    $oDB->Query( 'SELECT count(*) as countid FROM '.TABUSER.' WHERE name="'.$str.'"' );

    if ( $row = $oDB->Getrow() ) {
    if ( isset($row['countid']) ) {
    if ( $row['countid']==1 ) {

      $this->user->auth = true;

      // Get user info
      $oDB->Query('SELECT * FROM '.TABUSER.' WHERE name="'.$str.'"');
      $row = $oDB->Getrow();
      $this->user->id = (int)$row['id']; unset($row['id']); // unset in orther to not include this in the $_SESSION[QT.'_usr_info']
      $this->user->name = $name;         unset($row['name']);
      $this->user->role = $row['role'];  unset($row['role']);

      // Register VIP info in session
      $_SESSION[QT.'_usr_id'] = $this->user->id;
      $_SESSION[QT.'_usr_name'] = $this->user->name;
      $_SESSION[QT.'_usr_role'] = $this->user->role;
      $_SESSION[QT.'_usr_info'] = $row;
      unset($_SESSION[QT]['sys_domains']);
      unset($_SESSION[QT]['sys_sections']);
      return true;

    }}}

  }}

  return false;
}

// --------
// LOGOUT
// Remove session info (and cookie)

function Logout()
{
  unset($_SESSION);
  session_destroy();
  if ( isset($_COOKIE[QT.'_cookname']) ) setcookie(QT.'_cookname', '', time()+60*60*24*100, '/');
  if ( isset($_COOKIE[QT.'_cookpass']) ) setcookie(QT.'_cookpass', '', time()+60*60*24*100, '/');
}

// --------

function BackButton()
{
  if ( QTF_BACKBUTTON ) return '<a class="backbutton" href="'.Href($this->exiturl).'">'.QTF_BACKBUTTON.'</a>';
  return '';
}

// --------

public static function AddUser($username='',$password='',$mail='',$role='U',$child='0',$parentmail='')
{
  return cUser::AddUser($username,$password,$mail,$role,$child,$parentmail);
}

// --------

public static function SysCount($strObject='items',$strWhere='')
{
  global $oDB;
  switch($strObject)
  {
  case 'topics':
  case 'items':
    $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE id>=0'.$strWhere);
    $row = $oDB->Getrow();
    return intval($row['countid']);
    break;
  case 'replies':
    $oDB->Query('SELECT count(id) as countid FROM '.TABPOST.' WHERE type<>"P"'.$strWhere);
    $row = $oDB->Getrow();
    return intval($row['countid']);
    break;
  case 'members':
    $oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE id>0'.$strWhere);
    $row = $oDB->Getrow();
    return intval($row['countid']);
    break;
  case 'states':
    $arr = array();
      $oDB->Query('SELECT max(id) as countid FROM '.TABUSER.' WHERE id>=0'.$strWhere);
      $row = $oDB->Getrow();
    $arr['newuserid'] = intval($row['countid']);
      $oDB->Query('SELECT name,firstdate FROM '.TABUSER.' WHERE id='.$row['countid'] );
      $row = $oDB->Getrow();
    $arr['newusername'] = $row['name'];
    $arr['newuserdate'] = (empty($row['firstdate']) ? '0' : substr($row['firstdate'],0,8)); // date only
    return $arr;
    break;
  }
}

// --------

}