<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';

if ( $oVIP->user->role!='A' ) die('This page is for administrator only.');
if ( !isset($_GET['a'])) die('Wrong action');

include 'bin/qtf_fn_sql.php';
include Translate('qtf_adm.php');

// INITIALISE

$a = ''; // mandatory action
$d = -1; // domain (or days)
$s = -1; // section
$t = -1; // topic (or move target)
$p = -1; // post
$v = ''; // value
$ok = ''; // submitted
QThttpvar('a d s t p v ok','str int int int int str str');

$oVIP->selfurl  = 'qtf_adm_change.php';
$oVIP->selfname = 'QuickTalk command';

// remove scripts (jquery and base)

$oHtml->scripts = array();
unset($oHtml->links['jqueryui']);

// --------
// EXECUTE COMMAND
// --------

switch($a)
{

// --------------
case 'deletedomain':
// --------------

  if ( $d<1 ) die('Wrong id '.$d);

  $oVIP->selfname = $L['Domain_del'];
  $oVIP->exiturl = 'qtf_adm_sections.php';
  $oVIP->exitname = '&laquo; '.$L['Sections'];

  // ask destination
  if ( !isset($_GET['ok']) )
  {
    $arrDomains = GetDomains();
    $strTitle = $arrDomains[$d];
    $arrSections = QTarrget(GetSections($oVIP->user->role,$d));

    // list the domain content
    if ( count($arrSections)==0 )
    {
      $strCont = '<span class="small">0 '.$L['Section'].'</span>';
    }
    else
    {
      $strCont = '';
      foreach($arrSections as $intKey=>$strValue)
      {
      $strCont .= '<span class="small">'.$L['Section'].': '.$strValue.'</span><br/>';
      }
    }

    // list of domain destination

    $strDest = '';
    if ( count($arrSections)>0 )
    {
      $arrDest = array(); // array_diff_key() not supported in php<5.1
      foreach($arrDomains as $intKey=>$strValue) { if ( $intKey!=$d ) $arrDest[$intKey] = $strValue; }

      $strDest = PHP_EOL.'<tr class="tr"><td class="headfirst">'.$L['Sections'].'</td><td><select name="t" size="1" class="small">'.QTasTag($arrDest,'',array('format'=>$L['Move_to'].': %s')).'</select></td></tr>';
    }

    // form
    $oHtml->PageBox
    (
    NULL,
    '<form method="get" action="'.$oVIP->selfurl.'">
    <table class="data_o">
    <tr class="tr_o">
    <td class="headfirst" style="width:150px">'.$L['Title'].'</td>
    <td><b>'.$strTitle.'</b></td>
    </tr>
    <tr class="data_o">
    <td class="headfirst">'.$L['Containing'].'</td>
    <td>'.$strCont.'</td>
    </tr>'.$strDest.'
    <tr class="data_o">
    <td class="headfirst">&nbsp;</td>
    <td><input type="hidden" name="a" value="'.$a.'"/><input type="hidden" name="d" value="'.$d.'"/><input type="submit" name="ok" value="'.$L['Delete'].'"/></td>
    </tr>
    </table>
    </form>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Delete domain

  require_once 'bin/class/qtf_class_dom.php';
  if ( $t>=0 ) cDomain::MoveSections($d,$t);
  cDomain::Delete($d);

  // EXIT
  $_SESSION['pagedialog'] = 'O|'.$L['S_delete'];
  $oHtml->Redirect($oVIP->exiturl);
  break;

// --------------
case 'deletesection':
// --------------

  if ( $s<1 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Section_del'];
  $oVIP->exiturl  = 'qtf_adm_sections.php';
  $oVIP->exitname = '&laquo; '.$L['Sections'];

  // ask confirmation
  if ( !isset($_GET['ok']) )
  {
    $intTopics = cSection::CountItems($s,'items');
    $oHtml->PageBox
    (
    NULL,
    '<form method="get" action="'.$oVIP->selfurl.'">
    <table class="data_o">
    <tr class="data_o">
    <td class="headfirst" style="width:150px">'.$L['Section'].'</td>
    <td>'.$_SESSION[QT]['sys_sections'][$s].'</td>
    </tr>
    <tr class="data_o">
    <td class="headfirst">'.$L['Containing'].'</td>
    <td>'.L('Item',$intTopics).', '.L('Reply',cSection::CountItems($s,'replies')).'</td>
    </tr>
    '.( $intTopics>0 ? '<tr class="data_o"><td class="headfirst">&nbsp;</td><td><i><b>'.$L['H_Items_delete'].'</b></i></td></tr>': '').'
    <tr class="data_o">
    <td class="headfirst">&nbsp;</td>
    <td>
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/>'.( $intTopics>0 ? '&nbsp;&nbsp;<a href="qtf_adm_change.php?a=topicmoveall&amp;s='.$s.'&amp;d=10">'.$L['Adm_items_move'].' &raquo;</a>' : '').'</td>
    </tr>
    </table>
    </form>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Delete section
  cSection::Delete($s);

  $_SESSION['L'] = array();
  if ( isset($_SESSION[QT]['sys_sections']) ) unset($_SESSION[QT]['sys_sections']);

  // EXIT
  $_SESSION['pagedialog'] = 'O|'.$L['S_delete'];
  $oHtml->Redirect($oVIP->exiturl);
  break;

// --------------
case 'topicdeleteall':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Adm_items_delete'];
  $oVIP->exiturl  = 'qtf_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Items'];

  $t = cSection::CountItems($s,'items'); // number of topics before the action (stored as 't')

  // ask confirmation
  if ( empty($ok) )
  {
    $intReplies = cSection::CountItems($s,'replies');
    $intClosed = cSection::CountItems($s,'topicsZ');
    $intNews= cSection::CountItems($s,'news');
    $oHtml->PageBox
    (
    NULL,
    '<p><span class="bold">'.$L['All'].'</span> &middot; <a href="'.Href().'?a=topicdeleteyear&amp;s='.$s.'&amp;d='.$d.'">'.$L['By'].' '.strtolower($L['Year']).'</a></p>
    <form method="get" action="'.$oVIP->selfurl.'">
    <table  class="data_o">
    <tr>
    <td class="headfirst" style="width:150px;">'.$L['Section'].'</td>
    <td>'.$_SESSION[QT]['sys_sections'][$s].'</td>
    </tr>
    <tr>
    <td class="headfirst">'.$L['Containing'].'</td>
    <td>'.L('Item',$t).' ('.L('News',$intNews).', '.L('Reply',$intReplies).')</td>
    </tr>
    <tr>
    <td class="headfirst">&nbsp;</td>
    <td><i><b>'.$L['H_Items_delete'].'</b></i></td>
    </tr>
    <tr>
    <td class="headfirst">&nbsp;</td>
    <td>
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="t" value="'.$t.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/> <span class="small">('.$t.')</span>&nbsp;&nbsp;'.( $intClosed>0 ? ' <input type="submit" name="ok" value="'.$L['Delete_closed'].'"/> <span class="small">('.$intClosed.')</span>' : '').'</td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // delete topics (or closed only)
  $bClosedOnly = true; if ( $ok==$L['Delete'] ) $bClosedOnly = false;
  cSection::DeleteItems($s,$bClosedOnly);
  $t = $t - cSection::CountItems($s,'items');

  // EXIT
  if ( $t<1 )
    $_SESSION['pagedialog'] = 'W|'.$L['E_no_item'];
    else
    $_SESSION['pagedialog'] = 'O|'.$L['Items_deleted'].'|'.$t;
  $oHtml->Redirect($oVIP->exiturl);
  break;

// --------------
case 'topicdeleteyear':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Adm_items_delete'];
  $oVIP->exiturl  = 'qtf_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Items'];

  // Recompute stats

  $intCount = cSection::CountItems($s,'items'); // number of topics before the action
  $intYear = intval(date('Y'));
  $arrYears = array('old'=>($intYear-4).' and older',$intYear-3,$intYear-2,$intYear-1,$intYear);
  foreach($arrYears as $strKey=>$strValue) $arrYears[$strKey] .= strtolower(' -- '.L('Item',cSection::CountItems($s,'items',10,$strKey)).' ('.L('Closed',cSection::CountItems($s,'itemsZ',10,$strKey)).')');

  // ask confirmation and ask year
  if ( empty($ok) || empty($_GET['v']) )
  {
    $oHtml->PageBox
    (
    NULL,
    '<p><a href="'.Href().'?a=topicdeleteall&amp;s='.$s.'&amp;d='.$d.'">'.$L['All'].'</a> &middot; <span class="bold">'.$L['By'].' '.strtolower($L['Year']).'</span></p>
    <form method="get" action="'.$oVIP->selfurl.'">
    <table  class="data_o">
    <tr>
    <td class="headfirst" style="width:150px;">'.$L['Section'].'</td>
    <td>'.$_SESSION[QT]['sys_sections'][$s].'</td>
    </tr>
    <tr>
    <td class="headfirst">'.$L['Year'].'</td>
    <td><select id="v" name="v">'.QTasTag($arrYears).'</select></td>
    </tr>
    <tr>
    <td class="headfirst">&nbsp;</td>
    <td><i><b>'.$L['H_Items_delete'].'</b></i></td>
    </tr>
    <tr>
    <td class="headfirst">&nbsp;</td>
    <td>
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/> &nbsp;&nbsp; <input type="submit" name="ok" value="'.$L['Delete_closed'].'"/></td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // delete topics (or closed only)
  cSection::DeleteItems($s,$ok==$L['Delete_closed'],$v);
  $intCount = $intCount - cSection::CountItems($s,'items');

  // EXIT
  if ( $intCount<1 )
    $_SESSION['pagedialog'] = 'W|'.$L['E_no_item'];
    else
    $_SESSION['pagedialog'] = 'O|'.$L['Items_deleted'].'|'.$intCount;
  $oHtml->Redirect($oVIP->exiturl);
  break;

// --------------
case 'topicmoveall':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Adm_items_move'];
  $oVIP->exiturl  = 'qtf_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Items'];

  // Recompute stats

  $intCount = cSection::CountItems($s,'items'); // number of topics before the action
  $intClosed = cSection::CountItems($s,'itemsZ');
  $intNews = cSection::CountItems($s,'news');

  // Ask confirmation
  if ( empty($ok) || $t<0 )
  {
    $oHtml->PageBox
    (
    NULL,
    '<p><span class="bold">'.$L['All'].'</span> &middot; <a href="'.Href().'?a=topicmoveyear&amp;s='.$s.'&amp;d='.$d.'">'.$L['By'].' '.strtolower($L['Year']).'</a></p>
    <form method="get" action="'.$oVIP->selfurl.'">
    <table  class="data_o">
    <tr>
    <td class="headfirst" style="width:150px;">'.$L['Section'].'</td>
    <td>'.$_SESSION[QT]['sys_sections'][$s].'</td>
    </tr>
    <tr>
    <td class="headfirst">'.$L['Containing'].'</td>
    <td>'.L('Item',$intCount).' ('.L('News',$intNews).') , '.L('Reply',cSection::CountItems($s,'replies')).'</td>
    </tr>
    <tr>
    <td class="headfirst">'.$L['Move_to'].'</td>
    <td><select name="t" size="1">'.Sectionlist(-1,$s).'</select></td>
    </tr>
    <tr class="data_o">
    <td class="headfirst">'.$L['Ref'].'</td>
    <td><select name="p" size="1">
    <option value="1">'.$L['Move_keep'].'</option>
    <option value="0">'.$L['Move_reset'].'</option>
    <option value="2">'.$L['Move_follow'].'</option>
    </select></td>
    </tr>
    <tr>
    <td class="headfirst">&nbsp;</td>
    <td><input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="submit" name="ok" value="'.$L['Move'].'"/> <span class="small">('.$intCount.')</span>&nbsp;&nbsp;'.( $intClosed>0 ? ' <input type="submit" name="ok" value="'.$L['Move_closed'].'"/> <span class="small">('.$intClosed.')</span>' : '').'</td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // move topics
  cSection::MoveItems($s,$t,-1,$ok==$L['Move_closed'],'',$p);
  $intCount = $intCount - cSection::CountItems($s,'items');

  // EXIT
  if ( $intCount<1 )
    $_SESSION['pagedialog'] = 'W|'.$L['E_no_item'];
    else
    $_SESSION['pagedialog'] = 'O|'.$L['Items_moved'].'|'.$intCount;
  $oHtml->Redirect($oVIP->exiturl);
  break;

// --------------
case 'topicmoveyear':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Adm_items_move'];
  $oVIP->exiturl  = 'qtf_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Items'];

  $intCount = cSection::CountItems($s,'items'); // number of topics before the action
  $intYear = intval(date('Y'));
  $arrYears = array('old'=>($intYear-4).' and older',($intYear-3)=>$intYear-3,$intYear-2,$intYear-1,$intYear);
  foreach($arrYears as $strKey=>$strValue) $arrYears[$strKey] .= strtolower(' -- '.L('Item',cSection::CountItems($s,'items',10,$strKey)).' ('.L('Closed',cSection::CountItems($s,'itemsZ',10,$strKey)).')');

  // ask confirmation and ask year

  if ( empty($ok) || empty($_GET['v']) || $t<0 )
  {
    $oHtml->PageBox
    (
    NULL,
    '<p><a href="'.Href().'?a=topicmoveall&amp;s='.$s.'&amp;d='.$d.'">'.$L['All'].'</a> &middot; <span class="bold">'.$L['By'].' '.strtolower($L['Year']).'</span></p>
    <form method="get" action="'.$oVIP->selfurl.'">
    <table  class="data_o">
    <tr>
    <td class="headfirst" style="width:150px;">'.$L['Section'].'</td>
    <td>'.$_SESSION[QT]['sys_sections'][$s].'</td>
    </tr>
    <tr>
    <td class="headfirst">'.$L['Year'].'</td>
    <td><select id="v" name="v">'.QTasTag($arrYears).'</select></td>
    </tr>
    <tr>
    <td class="headfirst">'.$L['Move_to'].'</td>
    <td><select name="t" size="1">'.Sectionlist(-1,$s).'</select></td>
    </tr>
    <tr class="data_o">
    <td class="headfirst">'.$L['Ref'].'</td>
    <td><select name="p" size="1">
    <option value="1">'.$L['Move_keep'].'</option>
    <option value="0">'.$L['Move_reset'].'</option>
    <option value="2">'.$L['Move_follow'].'</option>
    </select></td>
    </tr>
    <tr>
    <td class="headfirst">&nbsp;</td>
    <td><input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="submit" name="ok" value="'.$L['Move'].'"/> &nbsp;&nbsp; <input type="submit" name="ok" value="'.$L['Move_closed'].'"/></td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // move topics
  cSection::MoveItems($s,$t,$p,-1,$ok==$L['Move_closed'],$v);
  $intCount = $intCount - cSection::CountItems($s,'items');

  // EXIT
  if ( $intCount<1 )
    $_SESSION['pagedialog'] = 'W|'.$L['E_no_item'];
    else
    $_SESSION['pagedialog'] = 'O|'.$L['Items_moved'].'|'.$intCount;
  $oHtml->Redirect($oVIP->exiturl);
  break;

// --------------
case 'topicprune':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);
  $d = 10; if ( isset($_GET['d']) ) $d = intval($_GET['d']);
  if ( $d<1 ) die('Wrong day '.$d);
  $intTopics = 0;
  $intNews = 0;
  if ( isset($_GET['tt']) ) $intTopics = $_GET['tt'];
  if ( isset($_GET['ta']) ) $intNews = $_GET['ta'];

  $intU = cSection::CountItems($s,'unreplied',$d);
  $intUN = cSection::CountItems($s,'unrepliednews',$d);

  $oVIP->selfname = $L['Adm_items_prune'];
  $oVIP->exiturl = 'qtf_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Items'];

  // ask confirmation
  if ( !isset($_GET['ok']) || ($intTopics+$intNews)==0 )
  {
    if ( isset($_GET['ok']) )
    {
      $error = '<span class="error">'.$L['E_nothing_selected'].'</span><br/>';
    }
    else
    {
      $error = '';
    }

    $oHtml->PageBox
    (
    NULL,
    '<form method="get" action="'.$oVIP->selfurl.'"><table class="data_o">
    <tr class="data_o">
    <td class="headfirst" style="width:150px;">'.$L['Section'].'</td>
    <td><b>'.ObjTrans('sec',$s,"Section $s").'</b></td>
    </tr>
    <tr class="data_o">
    <td class="headfirst">'.$L['Containing'].'</td>
    <td>'.L('Unreplied_item',$intU).' ('.L('News',$intUN).')</td>
    </tr>
    <tr class="data_o">
    <td class="headfirst">'.$L['Delete'].'</td>
    <td>
    <input type="checkbox" id="tt" name="tt" value="'.$intU.'"'.($intU==0 ? QDIS : '').'/>&nbsp;<label for="t">'.L('Item',$intU).'</label><br/>
    <input type="checkbox" id="ta" name="ta" value="'.$intUN.'"'.($intUN==0 ? QDIS : '').'/>&nbsp;<label for="a">'.L('News',$intUN).'</label></td>
    </tr>
    <tr class="data_o">
    <td class="headfirst">&nbsp;</td>
    <td><i><b>'.sprintf($L['H_Items_prune'],$d).'</b></i></td>
    </tr>
    <tr class="data_o">
    <td class="headfirst">&nbsp;</td>
    <td>
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/>
    </td></tr>
    </table></form><br/>'.$error,
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // dflt topics
  if ( $intTopics>0 )
  {
    $oDB->Query( 'SELECT t.id FROM '.TABTOPIC.' t WHERE t.forum='.$s.' AND t.replies=0 AND t.type="T" AND t.firstpostdate<"'.DateAdd(date('Ymd His'),-$d,'day').'"' );
    $strId = '';
    while ($row = $oDB->Getrow())
    {
      $strId .= $row['id'].',';
    }
    if ( !empty($strId) )
    {
      $strId = substr($strId,0,-1);
      // delete posts and topics
      $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic IN ('.$strId.')' );
      $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id IN ('.$strId.')' );
    }
  }

  // news topics
  if ( $intNews>0 )
  {
    $oDB->Query( 'SELECT t.id FROM '.TABTOPIC.' t WHERE t.forum='.$s.' AND t.replies=0 AND t.type="A" AND t.firstpostdate<"'.DateAdd(date('Ymd His'),-$d,'day').'"' );
    $strId = '';
    while ($row = $oDB->Getrow())
    {
      $strId .= $row['id'].',';
    }
    if ( !empty($strId) )
    {
      $strId = substr($strId,0,-1);
      // delete posts and topics
      $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic IN ('.$strId.')' );
      $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id IN ('.$strId.')' );
    }
  }

  // count topics in this section
  $oSEC = new cSection(); $oSEC->uid=$s;
  $oSEC->UpdateLastPostDate();
  $oSEC->UpdateReplies();

  // EXIT
  $_SESSION['pagedialog'] = 'O|'.$L['S_delete'];
  $oHtml->Redirect($oVIP->exiturl);
  break;

// --------------
default:
// --------------

  echo 'Unknown action';
  break;

// --------------
}

// Exit
$_SESSION['pagedialog'] = 'E|'.'Command ['.$a.'] failled...';
$oHtml->Redirect($oVIP->exiturl);
