<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
require_once 'bin/class/qtf_class_dom.php';
include Translate('qtf_adm.php');

if ( $oVIP->user->role!='A' ) die($L['E_admin']);

// INITIALISE

$id = -1; QThttpvar('id','int'); if ( $id<0 ) die('Missing argument id');

$oVIP->selfurl = 'qtf_adm_domain.php';
$oVIP->selfname = $L['Domain_upd'];
$oVIP->exiturl = 'qtf_adm_sections.php';
$oVIP->exitname = '&laquo; '.$L['Sections'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  $str = trim($_POST['title']); if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
  $str = QTconv($str,'3',QTF_CONVERT_AMP,false);
  if ( $str=='' ) $error = $L['Title'].' '.$L['E_invalid'];

  // save name and translations

  if ( empty($error) )
  {
  	cDomain::Rename($id,$str);

  	cLang::Delete(array('domain'),'d'.$id);
  	foreach($_POST as $strKey=>$str)
  	{
  		if ( substr($strKey,0,1)=='T' && !empty($str) )
  		{
  			$oGP = new cGetPost($str);
  			cLang::Add('domain',substr($strKey,1),'d'.$id,$oGP->e);
  		}
  	}
  }

  // Exit
  $_SESSION['pagedialog'] = (empty($error) ? 'O|'.$L['S_update'] : 'E|'.$error);
  $oHtml->Redirect($oVIP->exiturl,$oVIP->exitname);
}

// --------
// HTML START
// --------

$oHtml->scripts[] = '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length<1) { alert(qtHtmldecode("'.$L['E_mandatory'].' '.$L['Title'].'")); return false; }
  return null;
}
//-->
</script>
';

include 'qtf_adm_p_header.php';

if ( $id<0 ) die('Missing argument id');

$oDB->Query('SELECT title FROM '.TABDOMAIN.' WHERE id='.$id);
$row = $oDB->Getrow();

// FORM

echo '
<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<h2 class="subtitle">',$L['Domain'],'</h2>
<table class="data_o" width="500">
';
$str = QTconv($row['title'],'I');
echo '<tr class="data_o">
<td class="headfirst" style="width:100px;"><label for="title">',$L['Title'],'</label></td>
<td><input type="text" id="title" name="title" size="32" maxlength="64" value="',$str,'"/>',(strstr($str,'&amp;') ?  ' <span class="small">'.$row['title'].'</span>' : ''),'</td>
</tr>
';
echo '<tr class="data_o">
<td class="headfirst">',$L['Translations'],' *</td>
<td colspan="2">
<table  class="hidden">';

$arrTrans = cLang::Get('domain','*','d'.$id);
include 'bin/qtf_lang.php'; // this creates $arrLang
foreach($arrLang as $strIso=>$arr)
{
  $str = '';
  if ( isset($arrTrans[$strIso]) ) {
  if ( !empty($arrTrans[$strIso]) ) {
    $str = QTconv($arrTrans[$strIso],'I');
  }}
  echo '
  <tr>
  <td class="hidden" style="width:30px"><span title="',$arr[1],'">',$arr[0],'</span></td>
  <td class="hidden"><input class="small" title="',$L['Domain'],' (',$strIso,')" type="text" id="T',$strIso,'" name="T',$strIso,'" size="32" maxlength="64" value="',$str,'"/>',(strstr($str,'&amp;') ?  ' <span class="small">'.$arrTrans[$strIso].'</span>' : ''),'</td>
  </tr>
  ';
}

echo '</table>
</td>
</tr>
<tr class="data_o">
<td class="blanko" colspan="2">* <span class="small">',sprintf($L['E_no_translation'],$row['title']),'</span></td>
</tr>
</table>
<p style="margin:0 0 5px 0;text-align:center"><input type="hidden" name="id" value="',$id,'"/><input type="submit" name="ok" value="',$L['Save'],'"/></p>
</form>
<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>
';

// HTML END

include 'qtf_adm_p_footer.php';