<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
include Translate('qtf_adm.php');

if ( $oVIP->user->role!='A' ) die($L['E_admin']);

// INITIALISE

$oVIP->selfurl = 'qtf_adm_index.php';
$oVIP->selfname = '<span class="upper">'.$L['Adm_info'].'</span><br/>'.$L['Adm_status'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check admin email and forum url
  if ( !QTismail($_SESSION[QT]['admin_email'],false) ) $error='Error';
  if ( strlen($_SESSION[QT]['site_url'])<8 ) $error='Error';
  if ( !empty($error) )
  {
    $strFile=GetLang().'sys_online_error.php';
    if ( file_exists($strFile) ) { $strMsg = include $strFile; } else { $strMsg = '<p>Missing admin e-mail or forum url...</p>'; }
    $oVIP->exiturl = 'qtf_adm_site.php';
    $oVIP->exitname = $L['Adm_general'];
    $oHtml->PageBox(NULL,$strMsg,'admin',0);
  }

  if ( isset($_POST['offline']) ) {
  if ( $_POST['offline']=='1' || $_POST['offline']=='0' ) {
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_POST['offline'].'" WHERE param="board_offline"');
    $_SESSION[QT]['board_offline'] = $_POST['offline'];
  }}

  // exit
  $_SESSION['pagedialog'] = (empty($error) ? 'O|'.$L['S_save'] : 'E|'.$error);
}

// --------
// HTML START
// --------

include 'qtf_adm_p_header.php';

// BOARD OFFLINE

echo '<h2 class="subtitle">',$L['Adm_status'],'</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst">',$L['Adm_status'],'</td>';
if ( $_SESSION[QT]['board_offline']=='0' )
{
  echo '<td style="width:100px;background-color:#AAFFAA;text-align:center">',$L['On_line'],'</td>';
}
else
{
  echo '<td style="width:100px;background-color:#FFAAAA;text-align:center">',$L['Off_line'],'</td>';
}
echo '<td style="text-align:right">
<form method="post" action="',$oVIP->selfurl,'">
',$L['Change'],'&nbsp;
<select id="offline" name="offline" onchange="bEdited=true;" class="small">
<option value="0"',($_SESSION[QT]['board_offline']=='0' ? QSEL : ''),'>',$L['On_line'],'</option>
<option value="1"',($_SESSION[QT]['board_offline']=='1' ? QSEL : ''),'>',$L['Off_line'],'</option>
</select>&nbsp;<input class="small" type="submit" name="ok" value="',$L['Save'],'"/>
</form>
</td>
</tr>
</table>
';

// STATS

echo '<h2 class="subtitle">',$L['Info'],'</h2>',PHP_EOL;

$oDB->Query('SELECT count(id) as countid FROM '.TABDOMAIN);
$row = $oDB->Getrow();
$intDomain = $row['countid'];

$oDB->Query('SELECT count(id) as countid FROM '.TABSECTION);
$row = $oDB->Getrow();
$intForum = $row['countid'];

$oDB->Query('SELECT count(id) as countid FROM '.TABSECTION.' WHERE type="1"');
$row = $oDB->Getrow();
$intHidden = $row['countid'];

$oDB->Query('SELECT count(id) as countid FROM '.TABPOST);
$row = $oDB->Getrow();
$intPost = $row['countid'];

if ( $intPost>0 )
{
$oDB->Query('SELECT min(firstpostdate) as firsttopic FROM '.TABTOPIC);
$row = $oDB->Getrow();
$strStartdate = QTdatestr($row['firsttopic'],'$','');
}
else
{
$strStartdate = '&nbsp;';
}

echo '<table class="data_o">',PHP_EOL;
echo '<tr class="data_o">';
echo '<td class="headfirst">',$L['Domains'],'/',$L['Sections'],'</td>';
echo '<td>',L('Domain',$intDomain),', ',L('Section',$intForum),' <span class="small">(',L('Hidden',$intHidden),')</span>, <a href="qtf_stats.php">',$L['Statistics'],'</a></td>';
echo '</tr>',PHP_EOL;
echo '<tr class="data_o">';
echo '<td class="headfirst">',$L['Section_start_date'],'</td>';
echo '<td>',$strStartdate,'</td>';
echo '</tr>',PHP_EOL;
echo '<tr class="data_o">';
echo '<td class="headfirst">',$L['Members'],'</td>';

$oDB->Query('SELECT count(id) as countid FROM '.TABUSER);
$row = $oDB->Getrow();
$intUser = intval($row['countid']);
$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE role="A"');
$row = $oDB->Getrow();
$intAdmin = intval($row['countid']);
$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE role="M"');
$row = $oDB->Getrow();
$intMod = intval($row['countid']);

echo '<td>',L('Member',$intUser),' <span class="small">(',L('Userrole_A',$intAdmin),', ',L('Userrole_M',$intMod),', ',L('User',($intUser-$intAdmin-$intMod)),')</span></td>';
echo '</tr>',PHP_EOL;

// messages
$oDB->Query("SELECT count(id) as countid FROM ".TABTOPIC);
$row = $oDB->Getrow();
$intTopic = $row['countid'];
$oDB->Query('SELECT count(id) as countid FROM '.TABPOST.' WHERE type<>"P"');
$row = $oDB->Getrow();
$intReply = $row['countid'];

echo '<tr class="data_o">
<td class="headfirst">',$L['Messages'],'</td>
<td>',L('Message',$intPost),' <span class="small">(',L('Item',$intTopic),', ',L('Reply',$intReply),')</span></td>
</tr>
</table>
';

// PUBLIC ACCESS LEVEL

echo '<h2 class="subtitle">',$L['Public_access_level'],'</h2>',PHP_EOL;
echo '<table class="data_o">',PHP_EOL;
echo '<tr class="data_o">';
echo '<td class="headfirst">',$L['Visitors_can'],'</td>';
echo '<td>',$L['Pal'][$_SESSION[QT]['visitor_right']],' &middot; <a href="qtf_adm_secu.php">',$L['Change'],'</a></td>';
echo '</tr>',PHP_EOL,'</table>',PHP_EOL;

// VERSIONS

$str='';
if ( file_exists('bin/phpinfo.php') ) $str .= ' &middot; <a href="bin/phpinfo.php">php info</a>';
if ( file_exists('qtf_adm_const.php') ) $str .= ' &middot; <a href="qtf_adm_const.php">php constants</a>';

echo '
<h2 class="subtitle">',$L['Version'],'</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst">QuickTalk</td>
<td>',QTFVERSION,', <span class="small">database ',$_SESSION[QT]['version'],', sid ',QT,'</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="headfirst">PHP</td>
<td>'.PHP_VERSION_ID.$str.'</td>
</tr>
</table>
';

// HTML END

include 'qtf_adm_p_footer.php';