<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk forum
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
include Translate('qtf_adm.php');
include 'bin/qtf_fn_sql.php';

if ( $oVIP->user->role!='A' ) die(Error(13));

// INITIALISE

$d = 10; // days
$ok = '';
QThttpvar('d ok','int str');

$oVIP->selfurl = 'qtf_adm_topic.php';
$oVIP->selfname = '<span class="upper">'.$L['Adm_content'].'</span><br/>'.$L['Items'];
$oVIP->exitname = '&laquo; '.$L['Items'];

$arrStats = GetStats();

// --------
// SUBMITTED
// --------

if ( !empty($ok) )
{
  if ( !QTisbetween($d,1,99) ) { $error=$L['Days'].' '.Error(1).' (1-99)'; $d=10; }
}

// --------
// HTML START
// --------

include 'qtf_adm_p_header.php';

$arrDomains = GetDomains();

echo '<table class="data_s">
<tr class="data_o">
<th colspan="2">',$L['Domain'],'/',$L['Section'],'</th>
<th>',$L['Items'],'&nbsp;</th>
<th>',$L['Replys'],'&nbsp;</th>
<th>',$L['Unreplied'],'*&nbsp;</th>
<th class="thaction">',$L['Action'],'&nbsp;</th>
</tr>',PHP_EOL;

foreach($arrDomains as $intDomid=>$strDomtitle)
{

  echo '<tr class="data_o"><td class="colgroup" colspan="6">',$strDomtitle,'</td></tr>',PHP_EOL;

  $arrSections = QTarrget(GetSections('A',$intDomid)); // GET SECTIONS (with hidden)

  foreach($arrSections as $s=>$strValue)
  {
    $oSEC = new cSection($s);
    $intN = cSection::CountItems($s,'news');
    $intU = cSection::CountItems($s,'unreplied',$d);

    echo '<tr class="data_o">';
    echo '<td class="tdicon">',AsImg($oSEC->GetLogo(),'S',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'ico i_sec'),'</td>';
    echo '<td><span class="sectionname">',$oSEC->name,'</span><br/><span class="small">',$L['Section_type'][$oSEC->type],($oSEC->status=='1' ? '('.$L['Section_status'][1].')' : ''),'</span></td>';
    echo '<td>',$arrStats[$s]['topics'],'</td>';
    echo '<td>',$arrStats[$s]['replies'],'</td>';
    echo '<td>',$intU,'</td>';
    echo '<td class="tdaction">';
    if ( $arrStats[$s]['topics']>0 )
    {
    echo '<a class="small" href="qtf_adm_change.php?a=topicmoveall&amp;s=',$s,'&amp;d=',$d,'">',$L['Move'],'</a> &middot; ';
    echo '<a class="small" href="qtf_adm_change.php?a=topicdeleteall&amp;s=',$s,'&amp;d=',$d,'">',$L['Delete'],'</a> &middot; ';
    }
    else
    {
    echo '<span class="disabled">',$L['Move'],'</span> &middot; ';
    echo '<span class="disabled">',$L['Delete'],'</span> &middot; ';
    }
    if ( $intU>0 )
    {
    echo '<a class="small" href="qtf_adm_change.php?a=topicprune&amp;s=',$s,'&amp;d=',$d,'">',$L['Prune'],'</a>';
    }
    else
    {
    echo '<span class="disabled">',$L['Prune'],'</span>';
    }
    echo '</td></tr>',PHP_EOL;
  }
}
echo '</table>
';

echo '<h2 class="subtitle">* ',$L['Unreplied'],'</h2>
<table class="data_o">
';
echo '<tr class="data_o">
<td class="blanko">
<form method="post" action="',$oVIP->selfurl,'">';
printf($L['H_Unreplied'],'<input type="text" name="d" size="2" maxlength="2" value="'.$d.'" class="small"/>');
echo '&nbsp;<input type="submit" name="ok" value="',$L['Ok'],'"/></form>
</td>
</tr>
</table>
';
// HTML END

include 'qtf_adm_p_footer.php';