<?php
/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
include Translate('qtf_adm.php');
include Translate('qtf_reg.php');

if ( $oVIP->user->role!='A' ) die($L['E_admin']);

// INITIALISE

include 'bin/qtf_fn_sql.php';

$strGroups='';
$tpp = (int)$_SESSION[QT]['items_per_page']; if ( $tpp<20 ) $tpp=20;

$oVIP->selfurl = 'qtf_adm_users.php';
$oVIP->selfname = '<span class="upper">'.$L['Adm_content'].'</span><br/>'.$L['Members'];
$oVIP->exitname = '&laquo; '.$L['Members'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['del']) )
{
  if ( $_POST['cat']=='FM' ) $oDB->Query('DELETE FROM '.TABUSER.' WHERE firstdate=lastdate AND id>1');
  if ( $_POST['cat']=='SC' ) $oDB->Query('DELETE FROM '.TABUSER.' WHERE children="2" AND id>1');
  if ( $_POST['cat']=='SM' )
  {
    switch($oDB->type)
    {
    case 'mysql4':
    case 'mysql': $oDB->Query('DELETE FROM '.TABUSER.' WHERE LEFT(lastdate,8)<'.DateAdd(date('Ymd'),-1,'year').' AND id>1'); break;
    case 'sqlsrv':
    case 'mssql': $oDB->Query('DELETE FROM '.TABUSER.' WHERE LEFT(lastdate,8)<'.DateAdd(date('Ymd'),-1,'year').' AND id>1'); break;
    case 'pg':    $oDB->Query('DELETE FROM '.TABUSER.' WHERE SUBSTRING(lastdate,1,8)<'.DateAdd(date('Ymd'),-1,'year').' AND id>1'); break;
    case 'ibase': $oDB->Query('DELETE FROM '.TABUSER.' WHERE SUBSTRING(lastdate FROM 1 FOR 8)<'.DateAdd(date('Ymd'),-1,'year').' AND id>1'); break;
    case 'sqlite': $oDB->Query('DELETE FROM '.TABUSER.' WHERE SUBSTR(lastdate,1,8)<'.DateAdd(date('Ymd'),-1,'year').' AND id>1'); break;
    case 'db2':   $oDB->Query('DELETE FROM '.TABUSER.' WHERE SUBSTR(lastdate,1,8)<'.DateAdd(date('Ymd'),-1,'year').' AND id>1'); break;
    case 'oci':   $oDB->Query('DELETE FROM '.TABUSER.' WHERE SUBSTR(lastdate,1,8)<'.DateAdd(date('Ymd'),-1,'year').' AND id>1'); break;
    default: die('Unknown db type '.$oDB->type);
    }
  }
  echo '&laquo;&nbsp;<a href="qtf_adm_users.php">',$L['Members'],'</a>',PHP_EOL;
  echo '<meta http-equiv="REFRESH" content="3;url=qtf_adm_users.php">',PHP_EOL;
  exit;
}

// INITIALISE

$strGroup = 'all';
$intLimit = 0;
$intPage  = 1;
$strOrder = 'name';
$strDirec = 'ASC';
$strInver = 'DESC';
$strCateg = 'all';

// User menu (and jquery)

include 'qtf_usermenu.php';

// --------
// HTML START
// --------

include 'qtf_adm_p_header.php';

// --------
// CONTENT
// --------

if ( isset($_GET['group']) ) { $strGroup = substr($_GET['group'],0,3); }
if ( isset($_GET['page']) )  { $intLimit = (intval($_GET['page'])-1)*$tpp; $intPage = intval($_GET['page']); }
if ( isset($_GET['cat']) )   { $strCateg = $_GET['cat']; }
if ( isset($_GET['order']) ) { $strOrder = strip_tags(substr($_GET['order'],0,15)); } // protection against injection
if ( isset($_GET['dir']) )   { if ( $_GET['dir']=='DESC' ) $strDirec = 'DESC'; }      // protection against injection

if ( $strDirec=='DESC' ) $strInver='ASC';

// Global statistics  (count users)

  $oDB->Query('SELECT count(id) as countid FROM '.TABUSER);
  $row = $oDB->Getrow();
  $intUsers = $row['countid'];

// Global statistics  (count users without post)

  $oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE id>1 AND firstdate=lastdate');
  $row = $oDB->Getrow();
  $intFalse = $row['countid'];
  if ( $intFalse>0 )
  {
  $strFalse = '<a href="qtf_adm_users.php?cat=FM">[&raquo;]</a>';
  }else{
  $strFalse = '&nbsp;';
  }

// Global statistics  (count users sleeping 1 year)

  $oDB->Query('SELECT count(id) as numuser FROM '.TABUSER.' WHERE id>1 AND lastdate<"'.DateAdd(date('Ymd His'),-1,'year').'"');
  $row = $oDB->Getrow();
  $intSleeping = $row['numuser'];

  if ( $intSleeping>0 )
  {
  $strSleeping = '<a href="qtf_adm_users.php?cat=SM">[&raquo;]</a>';
  }else{
  $strSleeping = '&nbsp;';
  }

// Global statistics  (children and children without agreement)

  if ( $_SESSION[QT]['register_coppa']=='1' )
  {
    // children (all)
    $oDB->Query('SELECT count(id) as numuser FROM '.TABUSER.' WHERE id>1 AND children<>\'0\'');
    $row = $oDB->Getrow();
    $intChild = $row['numuser'];

    if ( $intChild>0 )
    {
    $strChild = '<a href="qtf_adm_users.php?cat=CH">[&raquo;]</a>';
    }
    else
    {
    $strChild = '&nbsp;';
    }

    // children (without agreement only)
    $oDB->Query('SELECT count(id) as numuser FROM '.TABUSER.' WHERE id>1 AND children="2"');
    $row = $oDB->Getrow();
    $intSleepchild = $row['numuser'];

    if ( $intSleepchild>0 )
    {
    $strSleepChild = '<a href="qtf_adm_users.php?cat=SC">[&raquo;]</a>';
    }
    else
    {
    $strSleepChild = '&nbsp;';
    }
  }

echo '
<table class="hidden">
<tr class="hidden">
<td class="hidden">
';
echo '
<table class="data_t">
<tr class="data_t">
<td class="colgroup">',$L['Members'],'</td>
<td class="colgroup">&nbsp;</td>
<td class="colgroup"><b>',$intUsers,'</b></td>
<td class="colgroup"><a href="qtf_adm_users.php">[&raquo;]</a></td>
</tr>
';
echo '<tr class="data_t hover">
<td>',$L['Members_FM'],'</td>
<td><span class="small">',$L['H_Members_FM'],'</span></td>
<td><b>',$intFalse,'</b></td>
<td>',$strFalse,'</td>
</tr>
';
echo '<tr class="data_t hover">
<td>',$L['Members_SM'],'</td>
<td><span class="small">',$L['H_Members_SM'],'</span></td>
<td><b>',$intSleeping,'</b></td>
<td>',$strSleeping,'</td>
</tr>
';
if ( $_SESSION[QT]['register_coppa']=='1' )
{
echo '<tr class="data_t hover">
<td>',$L['Members_CH'],'</td>
<td><span class="small">',$L['H_Members_CH'],'</span></td>
<td><b>',$intChild,'</b></td>
<td>',$strChild,'</td>
</tr>
';
echo '<tr class="data_t hover">
<td>',$L['Members_SC'],'</td>
<td><span class="small">',$L['H_Members_SC'],'</span></td>
<td><b>',$intSleepchild,'</b></td>
<td>',$strSleepChild,'</td>
</tr>
';
}
echo '</table>
</td>
<td class="hidden" style="width:20px">&nbsp;</td>
<td class="hidden" style="width:150px">
',$L['Top_participants'],'<br/>
<table class="hidden">
';

  // Top 5 participants
  $strState = 'name, id, numpost FROM '.TABUSER.' WHERE id>0';
  $oDB->Query( LimitSQL($strState,'numpost DESC',0,5) );

  For ($i=0;$i<5;$i++)
  {
    $row = $oDB->Getrow();
    if ( !$row ) break;
    echo '<tr><td><a href="qtf_user.php?id=',$row['id'],'">',$row['name'],'</a></td><td style="text-align:right">',$row['numpost'],'</td></tr>';
  }

echo '
</table>
</td>
</tr>
</table>
';

// Add user(s) form

echo '<p>',(empty($strUsermenu) ? '' : $strUsermenu.' | '),'<a href="qtf_adm_users_imp.php">',$L['Users_import_csv'],'...</a></p>';
if ( !empty($strUserform) ) echo $strUserform;

// --------
// Category subform
// --------

if ( $strCateg!='all' )
{
  echo '<h1>',$L['Members_'.$strCateg],' (',$L['H_Members_'.$strCateg],')</h1>',PHP_EOL;
  if ( $strCateg!='CH' )
  {
  echo '<form method="post" action="qtf_adm_users.php">';
  $intCount = $intFalse;
  if ( $strCateg=='SM' ) $intCount = $intSleeping;
  if ( $strCateg=='SC' ) $intCount = $intSleepchild;
  echo $L['Delete'],' ',$intCount,' ',$L['Members_'.$strCateg],'&nbsp;&nbsp;<input type="hidden" name="cat" value="',$strCateg,'"/><input type="submit" name="del" value="',$L['Delete'],' !"/></form>',PHP_EOL;
  }
}

// --------
// Button line and pager
// --------

if ( $strCateg=='all' ) $strGroups = HtmlLettres($strGroup,$L['All']);

// refine query
Switch ($strGroup)
{
  Case 'all': $strWhere = ' WHERE id>=0'; Break;
  Case '0':   $strWhere = ' WHERE '.FirstCharCase('name','a-z'); Break;
  Default:    $strWhere = ' WHERE '.FirstCharCase('name','u').'="'.$strGroup.'"'; Break;
}
// refine query by category
if ( $strCateg=='FM' ) $strWhere .= ' AND id>1 AND firstdate=lastdate'; //false members
if ( $strCateg=='SM' ) $strWhere .= ' AND id>1 AND lastdate<"'.DateAdd(date('Ymd His'),-1,'year').'"'; //sleeping members
if ( $strCateg=='CH' ) $strWhere .= ' AND id>1 AND children<>"0"'; //children
if ( $strCateg=='SC' ) $strWhere .= ' AND id>1 AND children="2"'; //sleeping children

// count query
$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.$strWhere);
$row = $oDB->Getrow();
$intCount = $row['countid'];

// -- build pager --

$strPager = MakePager("qtf_adm_users.php?cat=$strCateg&group=$strGroup&order=$strOrder&dir=$strDirec",$intCount,$tpp,$intPage);
if ( !empty($strPager) ) $strPager = $L['Page'].$strPager;
if ( $intCount<$intUsers ) $strPager = '<span class="small">'.$intCount.' '.$L['Selected_from'].' '.$intUsers.' '.strtolower($L['Members']).'</span>'.(empty($strPager) ? '' : ' | '.$strPager);

// -- Display button line and pager --

if ( $intCount>$tpp || $strGroup!='all' ) echo '<br/><table class="button"><tr>',PHP_EOL,$strGroups,PHP_EOL,'</tr></table>',PHP_EOL;
echo '<p class="pager_zt">',$strPager,'</p>',PHP_EOL;

// end if no result
if ( $intCount==0 )
{
  echo $L['None'];
  include 'qtf_adm_p_footer.php';
  exit;
}

// --------
// Memberlist
// --------

if ( $intCount!=0 )
{

  $img['NO']='';
  $img['ASC']= ' <img class="ico i_sort" src="admin/sort_asc.gif" alt="+"/>';
  $img['DESC']= ' <img class="ico i_sort" src="admin/sort_desc.gif" alt="-"/>';
  $sort['ASC']= 'DESC';
  $sort['DESC']= 'ASC';

  echo '<table class="data_t">',PHP_EOL;
  echo '<tr class="data_t">',PHP_EOL;
  if ( $intCount>2 )
  {
    echo '<th style="width:40px"><a href="qtf_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=id&amp;dir=' , $sort[$strDirec] , '">Id</a>' , ($strOrder=='id' ? $img[$strDirec] : $img['NO']) , '</th>',PHP_EOL;
    echo '<th><a href="qtf_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=name&amp;dir=' , $sort[$strDirec] , '">' , $L['Member'] , '</a>' , ($strOrder=='name' ? $img[$strDirec] : $img['NO']) , '</th>',PHP_EOL;
    echo '<th><a href="qtf_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=closed&amp;dir=' , $sort[$strDirec] , '">' , $L['Ban'] , '</a>' , ($strOrder=='closed' ? $img[$strDirec] : $img['NO']) , '</th>',PHP_EOL;
    echo '<th><a href="qtf_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=role&amp;dir=' , $sort[$strDirec] , '">' , $L['Role'] , '</a>' , ($strOrder=='role' ? $img[$strDirec] : $img['NO']) , '</th>',PHP_EOL;
    echo '<th>',$L['Action'],'</th>',PHP_EOL;
    echo '<th><a href="qtf_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=numpost&amp;dir=' , $sort[$strDirec] , '">' , $L['Messages'] , '</a>' , ($strOrder=='numpost' ? $img[$strDirec] : $img['NO']) , '</th>',PHP_EOL;
    if ( $strCateg=='FM' || $strCateg=='SC' )
    {
    echo '<th><a href="qtf_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=firstdate&amp;dir=' , $sort[$strDirec] , '">' , $L['Joined'] , '</a>' , ($strOrder=='firstdate' ? $img[$strDirec] : $img['NO']) , '</th>',PHP_EOL;
    }
    else
    {
    echo '<th><a href="qtf_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=lastdate&amp;dir=' , $sort[$strDirec] , '">' , $L['Last_message'] , '</a>' , ($strOrder=='lastdate' ? $img[$strDirec] : $img['NO']) , ' (ip)</th>',PHP_EOL;
    }
  }
  else
  {
    echo '<th style="width:40px">Id</th>',PHP_EOL;
    echo '<th>',$L['Member'],'</th>',PHP_EOL;
    echo '<th>',$L['Ban'],'</th>',PHP_EOL;
    echo '<th>',$L['Role'],'</th>',PHP_EOL;
    echo '<th>',$L['Action'],'</th>',PHP_EOL;
    echo '<th>',$L['Messages'],'</th>',PHP_EOL;
    if ( $strCateg=='FM' || $strCateg=='SC' )
    {
    echo '<th>',$L['Joined'],'</th>',PHP_EOL;
    }
    else
    {
    echo '<th>',$L['Last_message'],' (ip)</th>',PHP_EOL;
    }
  }
  echo '</tr>',PHP_EOL;

  //-- LIMIT QUERY --
  $strState = 'id,name,closed,role,numpost,firstdate,lastdate,ip FROM '.TABUSER.$strWhere;
  $oDB->Query( LimitSQL($strState,$strOrder.' '.$strDirec,$intLimit,$tpp,$intCount) );
  // --------

  For ($i=0;$i<$tpp;$i++)
  {
    $row = $oDB->Getrow();
    if ( !$row ) break;

    $strBan = $L['N'];
    if ( $row['closed']=='1' ) $strBan = '1';
    if ( $row['closed']=='2' ) $strBan = '10';
    if ( $row['closed']=='3' ) $strBan = '20';
    if ( $row['closed']=='4' ) $strBan = '30';
    echo '<tr class="data_t hover">',PHP_EOL;
    echo '<td><span class="small">',$row['id'].'</span></td>',PHP_EOL;
    echo '<td><a href="qtf_user.php?id=',$row['id'],'">',$row['name'],'</a></td>',PHP_EOL;
    echo '<td><span class="small',($strBan==$L['N'] ? ' disabled' : ''),'">',$strBan,'</span></td>',PHP_EOL;
    echo '<td><span class="small">',$L['Userrole_'.$row['role']],'</span></td>',PHP_EOL;
    echo '<td>',($row['id']>1 ? '<a class="small" href="qtf_change.php?a=user_ban&amp;p='.$row['id'].'&amp;v=adm">'.$L['Banish'].'</a> &middot; <a class="small" href="qtf_change.php?a=user_del&amp;p='.$row['id'].'&amp;v=adm">'.$L['Delete'].'</a>' : '&nbsp;'),'</td>',PHP_EOL;
    echo '<td>',$row['numpost'],'</td>',PHP_EOL;
    echo '<td>';
    if ( $strCateg=='FM' || $strCateg=='SC' )
    {
      echo '<span class="small">',QTdatestr($row['firstdate'],'$','$',true);
    }
    else
    {
      if ( $row['numpost']>0 )
      {
      echo '<span class="small">',QTdatestr($row['lastdate'],'$','$',true),' (',$row['ip'],')';
      }
      else
      {
      echo '<span class="disabled">',$L['None'];
      }
    }
    echo '</span></td>',PHP_EOL,'</tr>',PHP_EOL;
  }
  echo '</table>',PHP_EOL;

}
else
{
  echo $L['None'];
}

// -- Display pager --

echo '<p class="pager_zb">',$strPager,'</p>',PHP_EOL,PHP_EOL;

// HTML END

include 'qtf_adm_p_footer.php';