<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( !$oVIP->user->CanView('V2') ) HtmlPage(11);

$bShow = false;
if ( $_SESSION[QT]['show_calendar']=='V' ) $bShow = true;
if ( $_SESSION[QT]['show_calendar']=='U' && $oVIP->user->role!='V' ) $bShow = true;
if ( $_SESSION[QT]['show_calendar']=='M' && $oVIP->user->role=='M' ) $bShow = true;
if ( $oVIP->user->role=='A' ) $bShow = true;
if ( !$bShow ) HtmlPage(101);

// ---------
// FUNCTIONS
// ---------

include 'bin/qtf_fn_sql.php';

function FirstDayDisplay($intYear,$intMonth,$intWeekstart=1)
{
  // search date of the first 'monday' (or weekstart if not 1)
  // before the beginning of the month (to display gey-out in the calendar)
  if ( $intWeekstart<1 || $intWeekstart>7 ) die ('FirstDayDisplay: Arg #3 must be an int (1-7)');

  $arr = array(1=>'monday','tuesday','wednesday','thursday','friday','saturday','sunday'); // system weekdays reference
  $strWeekstart = $arr[$intWeekstart];
  $d = mktime(0,0,0,$intMonth,1,$intYear); // first day of the month
  if ( strtolower(date('l',$d))==$strWeekstart ) return $d;

  for($i=1;$i<8;$i++)
  {
    $d = strtotime('-1 day',$d);
    if ( strtolower(date('l',$d))==$strWeekstart ) return $d;
  }
  return $d;
}

function ArraySwap($arr,$n=1)
{
  // Move the first value to the end of the array. Action is repeated $n times. Keys are not moved.
  if ($n>0)
  {
    $arrK = array_keys($arr);
    while($n>0) { array_push($arr,array_shift($arr)); $n--; }
    $arrV = array_values($arr);
    $arr = array();
    for($i=0;$i<count($arrK);$i++) $arr[$arrK[$i]] = $arrV[$i];
  }
  return $arr;
}

// ---------
// INITIALISE
// ---------

$s = -1;
$v = 'birthday';
QThttpvar('s','int');

$intYear   = date('Y');  if ( isset($_GET['y']) ) $intYear = intval($_GET['y']);
$intYearN  = $intYear+1 ;
$intMonth  = date('n'); if ( isset($_GET['m']) ) $intMonth = intval($_GET['m']);
$intMonthN = $intMonth+1; if ( $intMonthN>12 ) { $intMonthN=1; $intYearN++; }
$strMonth  = '0'.$intMonth; $strMonth = substr($strMonth,-2,2);
$strMonthN = '0'.$intMonthN; $strMonthN = substr($strMonthN,-2,2);
$arrWeekCss = array(1=>'monday','tuesday','wednesday','thursday','friday','saturday','sunday'); // system weekdays reference

$dToday = mktime(0,0,0,date('n'),date('j'),date('Y'));

if ( $intYear>2100 ) die('Invalid year');
if ( $intYear<1900 ) die('Invalid year');
if ( $intMonth>12 ) die('Invalid month');
if ( $intMonth<1 ) die('Invalid month');

$oVIP->selfurl = 'qtf_calendar.php';
$oVIP->selfname = $L['Birthdays_calendar'];

// Shift language names and cssWeek to match with weekstart setting, if not 1 (monday)

if ( QTF_WEEKSTART>1 )
{
  $L['dateDDD'] = ArraySwap($L['dateDDD'],intval(QTF_WEEKSTART)-1);
  $L['dateDD'] = ArraySwap($L['dateDD'],intval(QTF_WEEKSTART)-1);
  $L['dateD'] = ArraySwap($L['dateD'],intval(QTF_WEEKSTART)-1);
  $arrWeekCss = ArraySwap($arrWeekCss,intval(QTF_WEEKSTART)-1);
}

// --------
// LIST OF ITEMS
// --------

$arrEvents = array();
$arrEventsN = array();
$intEvents = 0;
$intEventsN = 0;

switch($oDB->type)
{
// Select 2 months
case 'mysql4':
case 'mysql': $oDB->Query( 'SELECT id,name,role,'.$v.' FROM '.TABUSER.' WHERE SUBSTRING('.$v.',5,2)="'.$strMonth.'" OR SUBSTRING('.$v.',5,2)="'.$strMonthN.'"' ); break;
case 'sqlsrv':
case 'mssql': $oDB->Query( 'SELECT id,name,role,'.$v.' FROM '.TABUSER.' WHERE SUBSTRING('.$v.',5,2)="'.$strMonth.'" OR SUBSTRING('.$v.',5,2)="'.$strMonthN.'"' ); break;
case 'pg':    $oDB->Query( 'SELECT id,name,role,'.$v.' FROM '.TABUSER.' WHERE SUBSTRING('.$v.',5,2)="'.$strMonth.'" OR SUBSTRING('.$v.',5,2)="'.$strMonthN.'"' ); break;
case 'ibase': $oDB->Query( 'SELECT id,name,role,'.$v.' FROM '.TABUSER.' WHERE SUBSTRING('.$v.' FROM 5 FOR 2)="'.$strMonth.'" OR SUBSTRING('.$v.' FROM 5 FOR 2)="'.$strMonthN.'"' ); break;
case 'sqlite': $oDB->Query( 'SELECT id,name,role,'.$v.' FROM '.TABUSER.' WHERE SUBSTR('.$v.',5,2)="'.$strMonth.'" OR SUBSTR('.$v.',5,2)="'.$strMonthN.'"' ); break;
case 'db2':   $oDB->Query( 'SELECT id,name,role,'.$v.' FROM '.TABUSER.' WHERE SUBSTR('.$v.',5,2)="'.$strMonth.'" OR SUBSTR('.$v.',5,2)="'.$strMonthN.'"' ); break;
case 'oci':   $oDB->Query( 'SELECT id,name,role,'.$v.' FROM '.TABUSER.' WHERE SUBSTR('.$v.',5,2)="'.$strMonth.'" OR SUBSTR('.$v.',5,2)="'.$strMonthN.'"' ); break;
default: die('Unknown db type '.$oDB->type);
}
$i=0;
while($row=$oDB->Getrow())
{
  $i++;
  if ( strlen($row[$v])==8 )
  {
    $strM = substr($row[$v],4,2); $intM = intval($strM);
    $strD = substr($row[$v],6,2); $intD = intval($strD);
    if ( $strM==$strMonth ) { $arrEvents[$intD][]=$row; $intEvents++; }
    if ( $strM==$strMonthN ) { $arrEventsN[$intD]=1; $intEventsN++; }
  }
  if ( $i>8 ) break;
}

// --------
// HTML START
// --------

$oHtml->links['css'] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtf_index.css" />';
$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtf_calendar.css" />';
$oHtml->scripts_end[] = '<script type="text/javascript">
<!--
var roles = "'.$L['Userrole_A'].';'.$L['Userrole_M'].';'.$L['Userrole_U'].'";
$(function() {
  $(".ajaxmouseover").mouseover(function() {
    $.post("qtf_j_user.php",
      {id:this.id,dir:"'.QTF_DIR_PIC.'",roles:roles,ph:"'.$_SESSION[QT]['skin_dir'].'/user.gif"},
      function(data) { if ( data.length>0 ) document.getElementById("popupinfo").innerHTML=data; });
  });
});
//-->
</script>
';

include 'qtf_p_header.php';

echo '
<p id="sectiondesc">',$oVIP->selfname,'</p>
';

// PREPARE MAIN CALENDAR

$dCurrentDate = mktime(0,0,0,$intMonth,1,$intYear);
$dMainDate = $dCurrentDate;
$dFirstDay = mktime(0,0,0,$intMonth,1,$intYear);
if ( date('l',$dFirstDay)!='Monday' )
{
  $dFirstDay = strtotime('-1 week',$dFirstDay);
  $dFirstMonday = strtotime('next monday',$dFirstDay);
  // correction for php 4.2
  // find last monday
  for ($i=date('j',$dFirstDay);$i<32;$i++)
  {
    $dI = mktime(0,0,0,date('n',$dFirstDay),$i,date('Y',$dFirstDay));
    if ( !$dI )
    {
    if ( date('N',$dI)==1 ) $dFirstMonday = $dI;
    }
  }
  $dFirstDay = $dFirstMonday;
}
$intShiftWeek = intval(date('W',$dFirstDay)); if ( $intShiftWeek>53 ) $intShiftWeek==1;

// DISPLAY MAIN CALENDAR

echo '<table class="hidden" style="width:700px">',PHP_EOL,'<tr class="hidden" style="vertical-align:middle">',PHP_EOL;
echo '<td>';
if ( date('n',$dCurrentDate)>1 )
  echo '<a class="button" href="',$oVIP->selfurl,'?m=',(date('n',$dCurrentDate)-1),'">&lt;</a>';
  else
  echo '<a class="button disabled">&lt;</a>';
echo '<p id="thismonth">',$L['dateMMM'][date('n',$dCurrentDate)].' '.date('Y',$dCurrentDate),'</p>';
if ( date('n',$dCurrentDate)<12 )
  echo '<a class="button" href="',$oVIP->selfurl,'?m=',(date('n',$dCurrentDate)+1),'">&gt;</a>';
  else
  echo '<a class="button disabled">&gt;</a>';

echo '</td>',PHP_EOL;

echo '<td style="text-align:right;">';
echo '<form method="get" action="',$oVIP->selfurl,'">';
echo '<input type="hidden" name="y" id="y" value="',$intYear,'"/> ',PHP_EOL;
echo $L['Month'],' <select name="m" class="small" onchange="document.getElementById(\'ok\').click();">';
for ($i=1;$i<13;$i++)
{
echo '<option',($i==date('n') ? ' class="bold"' : ''),' value="',$i,'"',($i==$intMonth ? QSEL : ''),'>',$L['dateMMM'][$i],'</option>',PHP_EOL;
}
echo '</select> <input type="submit" name="ok" id="ok" class="small" value="',$L['Ok'],'"/><script type="text/javascript">document.getElementById("ok").style.display="none";</script></td>',PHP_EOL;
echo '</form></td>',PHP_EOL;
echo '</tr>',PHP_EOL,'</table>',PHP_EOL;

echo '<table class="data_o"  style="width:700px">',PHP_EOL;
echo '<tr class="data_o">',PHP_EOL;
echo '<th class="week date_first">&nbsp;</th>';
for ($i=1;$i<8;$i++)
{
  echo '<th class="date',($i==7 ? ' date_last' : ''),'" style="width:95px">',$L['dateDDD'][$i],'</th>',PHP_EOL;
}
echo '</tr>',PHP_EOL;

  $iShift=0;
  for ($intWeek=0;$intWeek<6;$intWeek++)
  {
    echo '<tr class="data_o">',PHP_EOL;
    echo '<td class="week">',$intShiftWeek,'</td>'; $intShiftWeek++;
    for ($intDay=1;$intDay<8;$intDay++)
    {
      $d = strtotime("+$iShift days",$dFirstDay); $iShift++;
      $intShiftYear = date('Y',$d);
      $intShiftMonth = date('n',$d);
      $intShiftDay = date('j',$d);

      // date number
      if ( date('n',$dCurrentDate)==date('n',$d) )
      {
        echo '<td class="date ',$arrWeekCss[$intDay],'"',(date('z',$dToday)==date('z',$d) ? ' id="zone_today">' : '>');
        echo '<p class="datenumber">',$intShiftDay,'</p><p class="dateicon">&nbsp;';
        // date info topic
        if ( isset($arrEvents[$intShiftDay]) )
        {
          $intDayEvents = 0;
          foreach($arrEvents[$intShiftDay] as $intKey=>$arrValues)
          {
            $intDayEvents++;
            $intAge = $intShiftYear - intval(substr($arrValues[$v],0,4));
            if ( $intDayEvents<4 )
            {
              echo '<a class="ajaxmouseover" id="u',$arrValues['id'],'" href="qtf_user.php?id=',$arrValues['id'],'">',$arrValues['name'],'</a> (',$intAge,')<br/>';
            }
            else
            {
              echo '<a class="ajaxmouseover" id="u',$arrValues['id'],'" href="qtf_user.php?id=',$arrValues['id'],'"><img class="ico i_user" src="',$_SESSION[QT]['skin_dir'],'/ico_user_p_1.gif" alt="-" title="',$arrValues['name'],' (',$intAge,')"/></a> ';
            }
            if ( $intDayEvents>7 ) break;
          }
        }
      }
      else
      {
        echo '<td class="date_out">';
        echo '<p class="datenumber">',$intShiftDay,'</p><p class="dateicon">&nbsp;';
      }
      echo '</p></td>',PHP_EOL;
    }
    echo '</tr>',PHP_EOL;
    if ( $intShiftMonth>$intMonth && $intShiftYear==$intYear ) break;
  }

echo '</table>',PHP_EOL,PHP_EOL;

// DISPLAY SUBDATA

echo '<table class="hidden">',PHP_EOL,'<tr class="hidden">',PHP_EOL;
echo '<td class="hidden" style="width:220px">',PHP_EOL;

  // PREPARE NEXT MONTH

  $dCurrentDate = mktime(0,0,0,$intMonthN,1,$intYearN);
  $dFirstDay = mktime(0,0,0,$intMonthN,1,$intYearN);
  if ( date("l",$dFirstDay)!='Monday' )
  {
    $dFirstDay = strtotime('-1 week',$dFirstDay);
    $dFirstMonday = strtotime('next monday',$dFirstDay);
    // correction for php 4.2
    // find last monday
    for ($i=date('j',$dFirstDay);$i<32;$i++)
    {
      $dI = mktime(0,0,0,date('n',$dFirstDay),$i,date('Y',$dFirstDay));
      if ( !$dI )
      {
      if ( date('N',$dI)==1 ) $dFirstMonday = $dI;
      }
    }
    $dFirstDay = $dFirstMonday;
  }

  // DISPLAY NEXT MONTH

  echo '<p id="nextmonth">',$L['dateMMM'][date('n',$dCurrentDate)],'</p>';
  echo '<table class="data_o"  style="width:200px">',PHP_EOL;
  echo '<tr class="data_o">',PHP_EOL;
  for ($intDay=1;$intDay<8;$intDay++)
  {
  echo '<th class="date_next">',$L['dateD'][$intDay],'</th>',PHP_EOL;
  }
  echo '</tr>',PHP_EOL;

    $iShift=0;
    for ($intWeek=0;$intWeek<6;$intWeek++)
    {
      echo '<tr class="data_o">',PHP_EOL;
      for ($intDay=1;$intDay<8;$intDay++)
      {
        $d = strtotime("+$iShift days",$dFirstDay); $iShift++;
        $intShiftYear = date('Y',$d);
        $intShiftMonth = date('n',$d);
        $intShiftDay = date('j',$d);
        // date number
        if ( date('n',$dCurrentDate)==date('n',$d) )
        {
          echo '<td class="date_next ',$arrWeekCss[$intDay],'"',(date('z',$dToday)==date('z',$d) ? ' id="zone_today"' : ''),'>';
          if ( isset($arrEventsN[$intShiftDay]) )
          {
            echo '<a class="date_next" href="qtf_calendar.php?m=',$intMonthN,'">',$intShiftDay,'</a> ';
          }
          else
          {
            echo $intShiftDay;
          }
        }
        else
        {
          echo '<td class="date_out_next">';
          echo $intShiftDay;
        }
        echo '</td>',PHP_EOL;
      }
      echo '</tr>',PHP_EOL;
      if ( $intShiftMonth>$intMonthN && $intShiftYear==$intYearN ) break;
    }

  echo '</table>',PHP_EOL,PHP_EOL;

echo '</td>',PHP_EOL;
echo '<td class="hidden" style="width:220px">',PHP_EOL;

  // DISPLAY STATS

  echo '<h2>',$L['Total'],'</h2>',PHP_EOL;
  echo '<br/>';
  echo '<p class="preview_section"><b>',$L['dateMMM'][date('n',$dMainDate)],'</b></p>',PHP_EOL;
  echo '<p class="preview_section">',L('User',$intEvents),'</p>',PHP_EOL;
  echo '<br/>';
  echo '<p class="preview_section"><b>',$L['dateMMM'][date('n',$dCurrentDate)],'</b></p>',PHP_EOL;
  echo '<p class="preview_section">',L('User',$intEventsN),'</p>',PHP_EOL;

echo '</td>',PHP_EOL;
echo '<td class="hidden" style="width:220px">',PHP_EOL;

  // DISPLAY Preview

  echo '<h2>',$L['Information'],'</h2>';
  echo '<script type="text/javascript"></script><noscript>Your browser does not support JavaScript</noscript>';
  echo '<div style="width:250px" id="popupinfo"></div>',PHP_EOL;

echo '</td>',PHP_EOL;

echo '<td>&nbsp;</td>',PHP_EOL;

echo '</tr>',PHP_EOL,'</table>',PHP_EOL,PHP_EOL;

// HTML END

include 'qtf_p_footer.php';