<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk forum
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( !$oVIP->user->CanView('V6') ) die(Error(11));

// INITIALISE

$s = -1; // section
$t = -1; // topic
$p = -1; // post
if (isset($_GET['s'])) $s = intval(strip_tags($_GET['s']));
if (isset($_POST['s'])) $s = intval(strip_tags($_POST['s']));
if (isset($_GET['t'])) $t = intval(strip_tags($_GET['t']));
if (isset($_POST['t'])) $t = intval(strip_tags($_POST['t']));
if (isset($_GET['p'])) $p = intval(strip_tags($_GET['p']));
if (isset($_POST['p'])) $p = intval(strip_tags($_POST['p']));
if ( $s<0 ) die('Missing parameters s');
if ( $t<0 ) die('Missing parameters t');
if ( $p<0 ) die('Missing parameters p');

$oSEC = new cSection($s);
$oTopic = new cTopic($t);
$oPost = new cPost($p);

$text = '';
$strDisabled = '';

$oVIP->selfurl  = 'qtf_form_del.php';
$oVIP->selfname = $L['Message'];
$oVIP->exiturl  = 'qtf_item.php?t='.$t;
$oVIP->exitname = '&laquo; '.$L['Item'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check user is creator (or M A)

  if ( $oVIP->user->role=='V' ) die($L['E_member']);
  if ( $oVIP->user->role=='U' && $oPost->userid!=$oVIP->user->id ) die($L['E_member']);

  // delete a reply
  if ( $oPost->type=='R' || $oPost->type=='D' )
  {
    // check & delete attachment
    if ( !empty($oPost->attach) )  if ( file_exists(QTF_DIR_DOC.$oPost->attach) ) unlink(QTF_DIR_DOC.$oPost->attach);
    // delete post
    $oDB->Query('DELETE FROM '.TABPOST.' WHERE id='.$p);
    // find the new topic lastpost
    $oDB->Query('SELECT max(id) as maxid FROM '.TABPOST.' WHERE topic='.$t);
    $row = $oDB->Getrow();
    $intPost = (int)$row['maxid'];
    $oTopic->UpdateTopicStats($t,$_SESSION[QT]['posts_per_item'],$intPost);
    $oVIP->exiturl = 'qtf_item.php?t='.$t;
  }

  // delete a post and the replies
  if ( $oPost->type=='P' )
  {
    // check & delete attachment
    if ( !empty($oPost->attach) ) if ( file_exists(QTF_DIR_DOC.$oPost->attach) ) unlink(QTF_DIR_DOC.$oPost->attach);
    // delete post and topic
    $oDB->Query('DELETE FROM '.TABPOST.' WHERE topic='.$t);
    $oDB->Query('DELETE FROM '.TABTOPIC.' WHERE id='.$t);
    $oVIP->exiturl = 'qtf_items.php?s='.$s;
  }

  // Exit

  $_SESSION['pagedialog'] = 'O|'.$L['S_delete'];
  $oHtml->Redirect($oVIP->exiturl);

}

// --------
// HTML START
// --------

$oVIP->selfname = $L['Delete_message'];

// CONTENT

include 'qtf_p_header.php';

echo '<h2>'.$oVIP->selfname.'</h2><br/>',PHP_EOL;
echo '<form method="post" action="',$oVIP->selfurl,'">',PHP_EOL;
echo '<input type="hidden" name="s" value="',$s,'"/>';
echo '<input type="hidden" name="t" value="',$t,'"/>';
echo '<input type="hidden" name="p" value="',$p,'"/>';
echo '<table class="data_o">',PHP_EOL;

echo '<tr>';
echo '<td class="headfirst" style="width:100px">',$L['Smiley'],'</td>';
echo '<td>';
if ( $oPost->icon==='00' )
  echo L('None');
else
  echo AsImg($_SESSION[QT]['skin_dir'].'/ico_prefix_'.$oSEC->prefix.'_'.$oPost->icon.'.gif','[o]',L('Ico_prefix_'.$oSEC->prefix.'_'.$oPost->icon),'ico ico_prefix');
echo '</td></tr>',PHP_EOL;
echo '<tr>';
echo '<td class="headfirst"><label for="title">',$L['Title'],'</label></td>';
echo '<td><input disabled="disabled" type="text" id="title" name="title" size="80" maxlength="100" value="',$oPost->title,'"/></td>';
echo '</tr>',PHP_EOL;
echo '<tr>';
echo '<td class="headfirst"><label for="oldtext">'.$L['Message'].'</label><br/></td>';
echo '<td>';
echo '<a href="textarea"></a>';
echo '<textarea'.QDIS.' id="oldtext" name="oldtext" rows="8" wrap="virtual" cols="80">',$oPost->text,'</textarea></td>';
echo '</tr>',PHP_EOL;
if ( $_SESSION[QT]['upload']!='0' ) {
if ( !empty($oPost->attach) ) {
echo '<tr>';
echo '<td class="headfirst">',$L['Attachment'],'</td>';
echo '<td><input'.QDIS.' type="text" size="75" value="',$oPost->attach,'"/><input type="hidden" id="attach" name="attach" value="'.$oPost->attach.'"/></td>';
echo '</tr>',PHP_EOL;
}}
if ( $oPost->type=='P' && $oTopic->replies>0 )
{
echo '<tr>';
echo '<td class="headfirst"><label for="text">',$L['Replys'],'</label><br/></td>';
echo '<td>',L('reply',$oTopic->replies),'</td>';
echo '</tr>',PHP_EOL;
}
echo '<tr>';
echo '<td class="headfirst">&nbsp;</td>';
echo '<td><input type="submit" name="ok" value="',$L['Delete'],'"/>&nbsp;';
if ( !empty($error) ) echo '<span class="error">',$error,'</span>';
echo '</td>';
echo '</tr>',PHP_EOL;
echo '</table>
</form>
<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>';

// HTML END

include 'qtf_p_footer.php';