<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk forum
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
$oHtml->links['css'] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtf_index.css" /><link rel="stylesheet" type="text/css" href="bin/css/qtf_print.css" media="print" />';

// --------
// SECURITY
// --------

if ( $_SESSION[QT]['board_offline']=='1' ) HtmlPage(99);
if ( $_SESSION[QT]['visitor_right']<1 && $oVIP->user->role=='V' ) HtmlPage(11);

// --------
// INITIALIZE
// --------

$arrStats = GetStats();

// Optimising queries: Search all lastpost and Sections attributes

$arrLastPostId = array();
$oDB->Query( 'SELECT forum,MAX(id) as maxid FROM '.TABPOST.' GROUP BY forum' );
while($row = $oDB->Getrow()) $arrLastPostId[(int)$row['forum']] = (int)$row['maxid'];
$arrSections = GetSections($oVIP->user->role,-2); // Get all sections at once (grouped by domain)

// --------
// HTML START
// --------

include 'qtf_p_header.php';

$table = new cTable('','data_s');
$table->th[0] = new cTableHead('&nbsp;','','thicon');
$table->th[1] = new cTableHead('&nbsp;','','thsection');
$table->th[2] = new cTableHead($L['Last_message'],'','thissue');
$table->th[3] = new cTableHead($L['Items'],'','thitems');
$table->th[4] = new cTableHead($L['Replys'],'','threplies');
$table->td[0] = new cTableData('','','tdicon');
$table->td[1] = new cTableData('','','tdsection');
$table->td[2] = new cTableData('','','tdissue');
$table->td[3] = new cTableData('','','tditems');
$table->td[4] = new cTableData('','','tdreplies');

$intDom = 0;
$intSec = 0;
$intSumItems = 0; // sum of items (for visible section)
$intSumNotes = 0; // sum of notes in process (for visible sections)
foreach($oVIP->domains as $intDomid=>$strDomtitle)
{
  if ( isset($arrSections[$intDomid]) ) {
  if ( count($arrSections[$intDomid])>0 ) {

    $intDom++;
    if ( $intDom>1 ) echo '<div class="dom_separator"></div>',PHP_EOL;
    echo '<!-- domain ',$intDomid,': ',$strDomtitle,' -->',PHP_EOL;
    $table->row = new cTableRow('', 'data_s');
    echo $table->Start().PHP_EOL;
    echo '<thead>',PHP_EOL;
    $table->th[1]->content = $strDomtitle;
    echo $table->GetTHrow().PHP_EOL;
    echo '</thead>',PHP_EOL;
    echo '<tbody>',PHP_EOL;

    $strAlt='r1';

    foreach($arrSections[$intDomid] as $intSection=>$arrSection)
    {
      $intSec++;
      $oSEC = new cSection($arrSection,(isset($arrLastPostId[$intSection]) ? $arrLastPostId[$intSection] : false)); //use query optimisation
      $strLastpost = '&nbsp;';
      if ( $arrStats[$intSection]['topics']>0 ) {
      if ( isset($oSEC->lastpostid) ) {
          $strLastpost = QTdatestr($oSEC->lastpostdate,'$','$',true,true,true);
          $strLastpost .= ' <a class="lastitem" href="'.Href('qtf_item.php').'?t='.$oSEC->lastposttopic.'#p'.$oSEC->lastpostid.'" title="'.$L['H_Goto_message'].'">'.$L['Goto_message'].'</a><br/>'.strtolower($L['By']).' <a href="qtf_user.php?id='.$oSEC->lastpostuser.'" title="'.$L['Ico_user_p'].'" class="small">'.$oSEC->lastpostname.'</a>';
      }}

      $table->row = new cTableRow('', 'data_s '.$strAlt.' hover');
      $table->td[0]->content = AsImg($oSEC->GetLogo(),'F',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'i_sec','',Href('qtf_items.php?s='.$oSEC->uid));
      $table->td[1]->content = '<a class="section" href="'.Href('qtf_items.php?s='.$oSEC->uid).'">'.$oSEC->name.'</a>'.(empty($oSEC->descr) ? '' : '<br/><span class="sectiondesc">'.$oSEC->descr.'</span>');
      $table->td[2]->content = $strLastpost;
      $table->td[3]->content = (isset($arrStats[$intSection]) ? $arrStats[$intSection]['topics'] : 0);
      $table->td[4]->content = (isset($arrStats[$intSection]) ? $arrStats[$intSection]['replies'] : 0);
      echo $table->GetTDrow().PHP_EOL;
      if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
    }
    echo '</tbody>',PHP_EOL;
    echo '</table>',PHP_EOL;

  }}
}

// No public section

if ( $intSec==0 ) echo '<p>',($oVIP->user->role=='V' ? $L['E_no_public_section'] : $L['E_no_visible_section']),'</p>';

// HTML END

if ( isset($oSEC) ) unset($oSEC);
include 'qtf_p_footer.php';