<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( !$oVIP->user->CanView('V2') ) HtmlPage(11);
include 'bin/qtf_fn_sql.php';

$s = ''; // section $s can be '*' or [int] (after argument checking only [int] is allowed)
$st = '*'; // status $st can be '*' or [int]
$q = '';
QThttpvar('s q st','str str str');
if ( $s==='*' || $s==='' ) $s=-1;
if ( $st==='' ) $st='*';
if ( !is_int($s) ) $s=(int)$s;
if ( $s<0 && empty($q) ) die('Missing argument $s or $q...');

// ---------
// INITIALISE
// ---------

if ( $s>=0 )
{
  $oSEC = new cSection($s);

  // exit if user role not granted
  if ( $oSEC->type==1 && ($oVIP->user->role=='V' || $oVIP->user->role=='U') )
  {
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oHtml->PageBox(NULL,$L['R_staff'],$_SESSION[QT]['skin_dir'],0);
  }
  if ( $oSEC->type==2 && $oVIP->user->role=='V' )
  {
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oHtml->PageBox(NULL,$L['R_member'],$_SESSION[QT]['skin_dir'],0);
  }
  $oVIP->selfname = $L['Section'].': '.$oSEC->name;
}
elseif ( !empty($q) )
{
  $oSEC = new cSection(); // section is null in case of search query
  $oVIP->selfname = L('Search_results');
}
else
{
  die('Missing argument $s or $q...');
}

$oVIP->selfurl = 'qtf_items.php';
$oVIP->selfuri = GetURI('order,dir');

$strCommand = '';
$arrMe[] = array();
$strRefineSearch = '';

$strOrder = 'lastpostdate';
$strDirec = 'desc';
$intPage = 1;
$intLimit = 0;
if ( isset($_GET['page']) ) { $intLimit = (intval($_GET['page'])-1)*$_SESSION[QT]['items_per_page']; $intPage = intval($_GET['page']); }
if ( isset($_GET['order']) ) $strOrder = $_GET['order'];
if ( isset($_GET['dir']) ) $strDirec = strtolower(substr($_GET['dir'],0,4));

// QUERY

$strOnTop = '';
if ( $_SESSION[QT]['news_on_top']==1 ) $strOnTop = 'CASE t.type WHEN "A" THEN "A" ELSE "Z" END as typea,';

$strFields = $strOnTop.'t.*,p.title,p.icon,p.id as postid,p.textmsg,p.issuedate,p.username';

if ( $s>=0 && empty($q) )
{
  $strFrom = ' FROM '.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid=p.id';
  $strWhere = ' WHERE t.forum='.$oSEC->uid;
  // Criteria sql: topics visible for current user ONLY
  if ( $oSEC->type==2 && !$oVIP->user->IsStaff() ) $strWhere .= ' AND (t.firstpostuser='.$oVIP->user->id.' OR t.type="A")';
  $strCount = 'SELECT count(*) as countid FROM '.TABTOPIC.' t'.$strWhere;
}
elseif ( !empty($q) )
{
  $strWhere = ' WHERE t.forum>=0';
  include 'qtf_items_qry.php';
}
else
{
  die('Missing argument $s or $q...');
}

// Option to hide closed items (no applied when status is part of the advanced query)

if ( $_SESSION[QT]['show_closed']=='0' && $st==='*' ) $strWhere.=' AND t.status<>"1"';

// Count topics visible for current user ONLY

$oDB->Query( $strCount );
$row = $oDB->Getrow();
$intCount = (int)$row['countid'];

// BUTTON LINE AND PAGER

if ( empty($q) )
{
  if ( $oSEC->status=='1' )
  {
    $strCommand = '<a class="button disabled">'.$L['E_section_closed'].'</a>';
  }
  else
  {
    $strCommand = '<a class="button" href="qtf_form_edit.php?s='.$oSEC->uid.'&amp;a=nt">'.$L['Post_new_item'].'</a>';
    if ( $oVIP->user->role=='V' && $_SESSION[QT]['visitor_right']<7 )
    {
    $strCommand = '<a class="button disabled">'.$L['Post_new_item'].'</a>';
    }
  }
}
$strCommand .= AsImg($_SESSION[QT]['skin_dir'].'/ico_search.gif','Search',$L['Search'],'ico i_search','',Href('qtf_search.php').'?'.$oVIP->selfuri,'','button');

$strPager = MakePager($oVIP->selfurl.'?'.$oVIP->selfuri,$intCount,(int)$_SESSION[QT]['items_per_page'],$intPage);
if ($strPager!='') $strPager = $L['Page'].$strPager;

// BUTTONS

$strCommand = $oVIP->BackButton().$strCommand;

// MAP

$bMap=false;
if ( UseModule('map') )
{
  include Translate('qtfm_map.php');
  include 'qtfm_map_lib.php';
  if ( QTgcanmap(empty($q) ? $oSEC->uid : 'S') ) $bMap=true;
  if ( $bMap ) $oHtml->links[]='<link rel="stylesheet" type="text/css" href="qtfm_map.css" />';

  if ( isset($_GET['hidemap']) ) $_SESSION[QT]['m_map_hidelist']=true;
  if ( isset($_GET['showmap']) ) $_SESSION[QT]['m_map_hidelist']=false;
  if ( !isset($_SESSION[QT]['m_map_hidelist']) ) $_SESSION[QT]['m_map_hidelist']=false;
}

// Usermenu

if ( $oVIP->user->IsStaff() ) include 'qtf_usermenu.php';

// --------
// HTML START
// --------

include 'qtf_p_header.php';

if ( isset($strUsermenu) ) echo $strUsermenu;

// Section or search result title/subtitle

echo '<p id="sectiondesc">';
switch($q)
{
  case '': if ($_SESSION[QT]['section_desc']=='1') if (!empty($oSEC->descr)) echo $oSEC->descr; break;
  case 'ref': echo sprintf( L('Search_results_ref'), $intCount, $v ); break;
  case 'kw':
    echo sprintf( L('Search_results_keyword'), $intCount, strtolower(implode(' '.L('or').' ',$arrVlbl)) );
    if ( count($arrV)==1 )
    {
      if ( strpos($v,' ')!==false ) $strRefineSearch = '<p><a href="'.$oVIP->selfurl.'?q=kw2&amp;v2='.$v2.'&amp;v='.urlencode($v).'" class="small">'.$L['Search_by_words'].'</a></p>';
    }
    break;
  case 'kw2':
    echo sprintf( L('Search_results_keyword'), $intCount, strtolower(implode(' '.L('and').' ',$arrVlbl)) );
    $strRefineSearch = '<p><a href="'.$oVIP->selfurl.'?q=kw&amp;v2='.$v2.'&amp;v='.urlencode(str_replace(',',' ',$v)).'" class="small">'.$L['Search_exact_words'].' "'.str_replace(',',' ',$v).'"</a></p>';
    break;
  case 'user': echo sprintf( L('Search_results_user'), $intCount, implode(' '.L('or').' ',$arrVlbl) ); break;
  case 'last': echo sprintf( L('Search_results_last'), $intCount ); break;
  case 'news': echo sprintf( L('Search_results_news'), $intCount ); break;
  case 'adv':
    echo sprintf( L(empty($arrVlbl) ? 'Search_results' : 'Search_results_tags'), $intCount, strtolower(implode(' '.L('or').' ',$arrVlbl)) ); break;
  default:
    if ( empty($arrVlbl) )
      echo L('items',$oSEC->items);
    else
      echo sprintf( L('Search_results'), $oSEC->items, implode(' '.L('or').' ',$arrVlbl) );
}
echo '</p>',PHP_EOL;
if (!empty($q) )
{
  $str = '';
  $arr = cTopic::GetStatuses();
  if ( $s>=0 ) $str .= L('only_in_section').' "'.$oVIP->sections[$s].'" ';
  if ( isset($st) && $st!=='*' ) $str .= L('only_status').' "'.$arr[(int)$st]['name'].'" ';
  if ( $q=='adv' && $v2!=='*' )
  {
    switch($v2)
    {
    case 'w': $str .= $L['This_week'].' '; break;
    case 'm': $str .= $L['This_month'].' '; break;
    case 'y': $str .= $L['This_year'].' '; break;
    default: $str .= (isset($L['dateMMM'][(int)$v2]) ? $L['dateMMM'][(int)$v2].' ' : '');
    }
  }
  if ( $q=='kw' && $v2=='1' ) $str .= L('In_title_only');
  if ( $q=='kw2' && $v2=='1' ) $str .= L('In_title_only');
  if ( !empty($str) ) echo '<p id="sectiondesc_sub">'.$str.'</p>',PHP_EOL;
}

echo $strRefineSearch;

// Buttons and pager

echo '<table class="pagertop"><tr>
<td class="pagerleft">',$strCommand,'</td>
<td class="pagercenter">&nbsp;</td>
<td class="pagerright">',$strPager,'</td>
</tr></table>
';

// End if no results

if ( $intCount==0 )
{
  $table = new cTable('t1','data_t',$intCount);
  $table->th['void'] = new cTableHead('&nbsp;');
  echo $table->GetEmptyTable('<p style="margin-left:10px;margin-right:10px">'.$L['E_no_item'].'...</p>',true,'','r1');
  include 'qtf_p_footer.php';
  exit;
}

// LIST TOPICS

// Last column: can be '0' (moderator requests no-field)

  if ( isset($_SESSION[QT]['lastcolumn']) ) $oSEC->d_last=$_SESSION[QT]['lastcolumn'];
  switch($oSEC->d_last)
  {
  case 'views': $str=$L['Views']; break;
  case 'status': $str=$L['Status']; break;
  case 'id': $str='Id'; break;
  case 'tags': $str=$L['Tags']; break;
  default: $oSEC->d_last=''; // hide any other column (i.e. 'none' or '-')
  }

// === TABLE DEFINITION ===

$table = new cTable('t1','data_t',$intCount);
$table->activecol = $strOrder;
$table->activelink = '<a  href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order='.$strOrder.'&amp;dir='.($strDirec=='asc' ? 'desc' : 'asc').'">%s</a> <img class="i_sort" src="'.$_SESSION[QT]['skin_dir'].'/sort_'.$strDirec.'.gif" alt="+"/>';
// column headers
$table->th['icon'] = new cTableHead('&bull;','','','<a href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order=status&amp;dir=asc">%s</a>');
if ( $q=='ref' || ($oSEC->numfield !=='N' && $oSEC->numfield !=='') )
$table->th['numid'] = new cTableHead($L['Ref'],'','','<a href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order=numid&amp;dir=desc">%s</a>');
if ( !empty($oSEC->prefix) )
$table->th['smile'] = new cTableHead('&nbsp;');
$table->th['title'] = new cTableHead($L['Items'],'','','<a href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order=title&amp;dir=asc">%s</a>');
if ( QTF_LIST_ME )
$table->th['youreply'] = new cTableHead('&nbsp;','','','<a href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order=you&amp;dir=asc">%s</a>');
if ( !empty($q) && $s<0 )
$table->th['sectiontitle'] = new cTableHead($L['Section']);
$table->th['firstpostname'] = new cTableHead($L['Author'],'','','<a href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order=firstpostname&amp;dir=asc">%s</a>');
$table->th['lastpostdate'] = new cTableHead($L['Last_message'],'','','<a href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order=firstpostdate&amp;dir=desc">%s</a>');
$table->th['replies'] = new cTableHead($L['Replys'],'','','<a href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order=replies&amp;dir=desc">%s</a>');
if ( !empty($oSEC->d_last) )
{
  $table->th[$oSEC->d_last] = new cTableHead($str,'','','<a href="'.$oVIP->selfurl.'?'.$oVIP->selfuri.'&amp;order='.$oSEC->d_last.'&amp;dir=desc">%s</a>');
}

// create column data (from headers identifiers) and add class to all
foreach($table->th as $key=>$th) { $table->th[$key]->Add('class','th'.$key); $table->td[$key] = new cTableData('','','td'.$key); }

// prepare dynamic style for 'status'
if ( isset($table->td['status']) ) $table->td['status']->dynamicValues = array('0'=>'opened','1'=>'closed');

// pre-compute user's items
if ( QTF_LIST_ME && cUser::GetUserInfo('numpost',0,true)>0 )
{
  if ( $s>=0 )
  {
  $oDB->Query( 'SELECT p.topic,p.issuedate FROM '.TABPOST.' p WHERE p.forum='.$s.' AND p.type="R" AND p.userid='.$oVIP->user->id );
  while($row=$oDB->Getrow()) $arrMe[(int)$row['topic']] = (string)$row['issuedate'];
  }
  elseif ( !empty($q) )
  {
  $str = str_replace('p.type="P"','p.type="R"',$strWhere); // as seaching for replies, change p.type in criteria
  if ( strpos($str,'p.type="R"')===false ) $str .= ' AND p.type="R"'; // add p.type if missing
  $oDB->Query( 'SELECT p.topic,p.issuedate '.$strFrom.$str.' AND p.userid='.$oVIP->user->id);
  while($row=$oDB->Getrow()) $arrMe[(int)$row['topic']] = (string)$row['issuedate'];
  }
}

// pre-compute section numfield formats
if ( isset($table->th['numid']) || isset($table->th['smile']) )
{
  if ( !isset($_SESSION[QT]['sys_sections_flds']) ) cSection::GetEachFields('numfield,prefix',true); // register array(section_id=>numfield) in sys_numfields
}

// === TABLE START DISPLAY ===

echo PHP_EOL;
echo $table->Start().PHP_EOL;
echo '<thead>'.PHP_EOL;
echo $table->GetTHrow('','hidden').PHP_EOL;
echo '</thead>'.PHP_EOL;
echo '<tbody>'.PHP_EOL;

// ========
if ( $strOrder=='title' ) { $strFullOrder='p.title'; } else { $strFullOrder='t.'.$strOrder; }
$oDB->Query( LimitSQL($strFields.$strFrom.$strWhere,(empty($strOnTop) ? '' : 'typea ASC, ').$strFullOrder.' '.strtoupper($strDirec),$intLimit,$_SESSION[QT]['items_per_page'],$intCount) );
// ========

$intWhile=0;
$strAlt='r1';
$arrTags=array();
while($row=$oDB->Getrow())
{
	// prepare row
	$table->row = new cTableRow('','data_t '.$strAlt.' hover');

	// prepare values, and insert value into the cells
	$table->SetTDcontent( FormatTableRow('t1',$table->GetTHnames(),$row,$oSEC,$bMap), false ); // adding extra columns not allowed

	// handle dynamic style
	if ( isset($table->td['status']) ) $table->td['status']->AddDynamicAttr('class', $row['status']);


	//show row content
	echo $table->GetTDrow().PHP_EOL;

	if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }

	// collect tags
	if (QTF_LIST_TAG && !empty($_SESSION[QT]['tags']) && count($arrTags)<51 )
	{
	  if ( !empty($row['tags']) ) $arrTags = array_unique($arrTags + explode(';',$row['tags']));
	}

	$intWhile++;
	//odbcbreak
	if ( $intWhile>=$_SESSION[QT]['items_per_page'] ) break;
}

// === TABLE END DISPLAY ===

echo '</tbody>
</table>
';

// BUTTON LINE AND PAGER

$strCsv = ($oVIP->user->role=='V' ? '' : HtmlCsvLink(Href('qtf_items_csv.php').'?'.$oVIP->selfuri,$intCount,$intPage));
if ( !empty($strCsv) )
{
  $strPager = $strCsv.' &middot; '.$strPager;
  if ( substr($strPager,-10,10)==' &middot; ' ) $strPager = substr($strPager,0,-10);
}

// display button, pager and csv

if ( $intCount>2 )
{
echo '<table class="pagerbot"><tr>
<td class="pagerleft">',$strCommand,'</td>
<td class="pagercenter">&nbsp;</td>
<td class="pagerright">',$strPager,'</td>
</tr></table>
';
}
else
{
echo '<p id="pager_zb" class="csv">&nbsp;',$strPager,'</p>';
}

// TAGS FILTRING

if ( QTF_LIST_TAG && !empty($_SESSION[QT]['tags']) && count($arrTags)>0 )
{
  echo '<p class="tagbox">'.$L['Show_only_tag'],'</p><div class="tagbox">';
  foreach($arrTags as $strTag)
  {
    echo '<a class="tag',(count($arrTags)>12 ? ' small' : ''),'" href="qtf_items.php?s=',$s,'&amp;q=adv&amp;v2=*&amp;v=',urlencode($strTag),'">',$strTag,'</a>';
  }
  echo '</div>';
}

// --------
// HTML END
// --------

// TAG infotip

if ( !empty($_SESSION[QT]['tags']) )
{
$strFooterScript = '<script type="text/javascript">
<!--
$(document).ready(function () {
  $(".tag").hover(function() {
    var oTag = $(this);
    $.post("qtf_j_tagdesc.php",{s:"'.$s.'",val:oTag.html(),lang:"'.GetIso().'",na:"('.L('e_no_desc').')"}, function(data) { oTag.attr({title:data}); } );
  });
});
//-->
</script>
';
}

include 'qtf_p_footer.php';