<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
$oHtml->links['css'] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtf_index.css" /><link rel="stylesheet" type="text/css" href="bin/css/qtf_print.css" media="print" />';
include Translate('qtf_reg.php');

// INITIALISE

$oVIP->selfurl = 'qtf_login.php';
$oVIP->selfname = $L['Login'];

$strName = '';
if ( isset($_GET['dfltname']) )
{
  $strName=$_GET['dfltname']; if ( get_magic_quotes_gpc() ) $strName = stripslashes($strName);
  $strName=QTconv($strName,'U');
}

// --------
// SUBMITTED for login
// --------

if ( isset($_POST['ok']) )
{
  // CHECK FORM VALUE

  $strName = trim($_POST['title']); if ( get_magic_quotes_gpc() ) $strName = stripslashes($strName);
  $strName = QTconv($strName,'U',false,false);
  if ( !QTislogin($strName) ) $error = $L['Username'].' '.Error(1);

  $strPwd = trim($_POST['pwd']); if ( get_magic_quotes_gpc() ) $strPwd = stripslashes($strPwd);
  $strPwd = QTconv($strPwd,'U',false,false);
  if ( !QTispassword($strPwd) ) $error = $L['Password'].' '.Error(1);

  // EXECUTE

  if ( empty($error) )
  {
    $oVIP->user->Login($strName,$strPwd,isset($_POST['remember']));

    if ( $oVIP->user->auth )
    {
      // check registered if children and coppa active (0=Adult, 1=Kid aggreed, 2=Kid not aggreed)
      if ( $_SESSION[QT]['register_coppa']=='1' )
      {
        $arrCoppa = $oVIP->GetCoppa($oVIP->user->id);
        if ( isset($arrCoppa['children']) && $arrCoppa['children']=='2' )
        {
        $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
        cUser::SessionUnset();
        $oHtml->PageBox(NULL,'<h2>'.$L['Welcome'].' '.$strName.'</h2>'.$L['E_access'].'<br/>'.L('No_parental_confirm'),$_SESSION[QT]['skin_dir'],0,'350px','login_header','login');
        }
      }

      // check ban

      $ban = cUser::GetUserInfo('closed',0,true);
      if ( $ban>0 )
      {
      	$items = cUser::GetUserInfo('numpost',0,true);
      	// protection against hacking of admin/moderator
        if ( $oVIP->user->id<2 || $oVIP->user->IsStaff() || $items==0 )
        {
        $oDB->Query( 'UPDATE '.TABUSER.' SET closed="0" WHERE id='.$oVIP->user->id );
        $oVIP->exiturl = 'qtf_login.php?dfltname='.$strName;
        $oVIP->exitname = $L['Login'];
        cUser::SessionUnset();
        $oHtml->PageBox(NULL,'<p>'.$L['Is_banned_nomore'].'</p>',$_SESSION[QT]['skin_dir'],0);
        }

        // end ban control
      	$last = cUser::GetUserInfo('lastdate','20000101');
        $intDays = 1;
        if ( $ban==2 ) $intDays = 10;
        if ( $ban==3 ) $intDays = 20;
        if ( $ban==4 ) $intDays = 30;
        $endban = DateAdd(substr($last,0,8),$intDays,'day');

        if ( date('Ymd')>$endban )
        {
          $oDB->Query( 'UPDATE '.TABUSER.' SET closed="0" WHERE id='.$oVIP->user->id );
          $oVIP->exiturl = 'qtf_login.php?dfltname='.$strName;
          $oVIP->exitname = $L['Login'];
          cUser::SessionUnset();
          $oHtml->PageBox(NULL,'<p>'.$L['Is_banned_nomore'].'</p>',$_SESSION[QT]['skin_dir'],0,'350px','login_header','login');
        }
        else
        {
          cUser::SessionUnset();
          $oHtml->PageBox(NULL,'<h2>'.$strName.' '.strtolower($L['Is_banned']).'</h2><p>'.Error(10).'</p><p>'.$L['Retry_tomorrow'].'</p>',$_SESSION[QT]['skin_dir'],0,'350px','login_header','login');
        }
      }

      // upgrade profile
      $oDB->Query( 'SELECT secret_a FROM '.TABUSER.' WHERE id='.$oVIP->user->id );
      $row = $oDB->Getrow();
      if ( empty($row['secret_a']) )
      {
      $oVIP->exiturl = 'qtf_user_question.php?id='.$oVIP->user->id;
      $oVIP->exitname = $L['Secret_question'];
      $oHtml->PageBox(NULL,'<h2>'.$L['Welcome'].' '.$strName.'</h2><br/><p/>'.$L['Update_secret_question'].'</p>',$_SESSION[QT]['skin_dir'],0,'400px','login_header','login');
      }

      // end message
      $_SESSION['pagedialog']='L|'.$L['Welcome'].' '.$strName;
      $oHtml->Redirect('qtf_index.php');
    }
    else
    {
      $error = Error(10);
    }
  }
  $_SESSION['pagedialog']='E|'.L('E_access');
}

// --------
// SUBMITTED for loggout
// --------

if ( isset($_GET['a']) ) {
if ( $_GET['a']=='out' ) {

  // LOGGING OUT

  $oVIP->Logout();

  // REBOOT

  GetParam(true);

  // check major parameters
  if ( !isset($_SESSION[QT]['skin_dir']) ) $_SESSION[QT]['skin_dir']='skin/default';
  if ( !isset($_SESSION[QT]['language']) ) $_SESSION[QT]['language']='english';
  if ( empty($_SESSION[QT]['skin_dir']) ) $_SESSION[QT]['skin_dir']='skin/default';
  if ( empty($_SESSION[QT]['language']) ) $_SESSION[QT]['language']='english';
  if ( substr($_SESSION[QT]['skin_dir'],0,5)!='skin/' ) $_SESSION[QT]['skin_dir'] = 'skin/'.$_SESSION[QT]['skin_dir'];

  session_start();
  $_SESSION['pagedialog']='L|'.L('Goodbye');
  $oHtml->Redirect('qtf_index.php');

}}

// --------
// HTML START
// --------

$oHtml->scripts_end[] = '<script type="text/javascript">
<!--
var doc = document.getElementById("title");
doc.focus();
if ( doc.value.length>1 ) { document.getElementById("pwd").focus(); }
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("'.$L['Missing'].': '.$L['Username'].'")); return false; }
  if (theForm.pwd.value.length==0) { alert(qtHtmldecode("'.$L['Missing'].': '.$L['Password'].'")); return false; }
  return null;
}
//-->
</script>
';

include 'qtf_p_header.php';

$oHtml->MsgBox($oVIP->selfname,'msgbox login,msgboxtitle login,msgboxbody login');

if ( !empty($error) ) echo '<span class="error">',$error,'</span>&nbsp;';
echo '<form method="post" action="',Href(),'" onsubmit="return ValidateForm(this);">
<p><label for="title">',$L['Username'],'</label>&nbsp;<input type="text" id="title" name="title" pattern="^.{2}.*" size="20" maxlength="24" value="',$strName,'"/></p>
<p><label for="pwd">',$L['Password'],'</label>&nbsp;<input type="password" id="pwd" name="pwd" pattern="^.{4}.*" title="'.sprintf(L('E_char_min'),4).'" size="20" maxlength="24"/></p>
<p><input type="checkbox" id="remember" name="remember"/>&nbsp;<label for="remember">',$L['Remember'],'</label>&nbsp;&nbsp;
<input type="submit" name="ok" value="',$L['Ok'],'"/>&nbsp;</p>
<p style="text-align:right"><a class="small" href="',Href('qtf_user_new.php'),'">',$L['Register'],'</a> &middot; <a class="small" href="',Href('qtf_reset_pwd.php'),'?a=id">',$L['Forgotten_pwd'],'</a>&nbsp;</p>
</form>
';

$oHtml->MsgBox(END);

// HTML END

include 'qtf_p_footer.php';