<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
require_once 'bin/qtf_fn_tags.php';
if ( !$oVIP->user->CanView('V5') ) HtmlPage(11);

// INITIALISE

$oVIP->selfurl = 'qtf_search.php';
$oVIP->selfname = $L['Search'];
$oVIP->exitname = $L['Search'];

$strAction = 'ref';

$tt = 0;  // tab index
$q = '';  // query model
$v = '';
$v2 = '';
$s = '*';  // section filter can be '*' or [int]
$st = '*';
$y = 0;

QThttpvar('q v v2 s st y','str str str str str int');

if ( isset($_POST['s_ref']) ) $s = strip_tags($_POST['s_ref']);
if ( isset($_POST['s_id']) ) $s = strip_tags($_POST['s_id']);
if ( isset($_POST['s_kw']) ) $s = strip_tags($_POST['s_kw']);
if ( isset($_POST['s_adv']) ) $s = strip_tags($_POST['s_adv']);
if ( isset($_POST['st_ref']) ) $st = strip_tags($_POST['st_ref']);
if ( isset($_POST['st_id']) ) $st = strip_tags($_POST['st_id']);
if ( isset($_POST['st_kw']) ) $st = strip_tags($_POST['st_kw']);
if ( isset($_POST['st_adv']) ) $st = strip_tags($_POST['st_adv']);
if ( $s==='' || $s==='-1' ) $s='*';
if ( $st==='' ) $st='*';
if ( $tt<0 || $tt>2 ) $tt=0;
if ( $s!=='*' ) $s=(int)$s;
if ( $st!=='*' ) $st=(int)$st;

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) && !empty($q) )
{
  $str=''; // criterias (other than filters)
  switch($q)
  {
  case 'ref':
    if ( empty($v) ) $error = $L['Ref'].' '.$L['E_invalid'];
    $str = '&amp;v='.urlencode($v);
    break;
  case 'kw':
    if ( empty($v) ) $error = $L['Keywords'].' '.$L['E_invalid'];
    $str = '&amp;v='.urlencode($v).'&amp;v2='.(isset($_POST['v2']) ? '1' : '0');
    break;
  case 'adv':
    if ( $v2==='-' || $v2==='--' || $st==='-' ) $error = $L['Date'].' & '.$L['Status'].' '.$L['E_invalid'];
    if ( $v2==='-1' && $st==='-1' && empty($v) ) $error = $L['Date'].' & '.$L['Status'].' & Tag '.$L['E_invalid'];
    if ( $v===';' ) $error = 'Tag '.$L['E_invalid'];
    $str = '&amp;y='.$y.'&amp;v2='.$v2.'&amp;v='.urlencode($v);
    break;
  default: die('Unknown criteria '.$q);
  }
  // redirect
  if ( empty($error) )
  {
    $oVIP->exiturl = 'qtf_items.php?s='.$s.'&amp;q='.$q.$str;
    $oHtml->PageBox('0');
    exit;
  }
}

// --------
// HTML START
// --------

$arrTags = cSection::GetTagsUsed(-1);
if ( count($arrTags)>0 ) $arrTags = TagsDesc($arrTags);
$str  = '';
foreach($arrTags as $strKey=>$strDesc) { $str .= '"'.$strKey.'",'; }
$str = substr($str,0,-1);

$oHtml->links['css'] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtf_search.css" />';
$oHtml->scripts[] = '<script type="text/javascript">
<!--
var e0 = "'.L('No_result').'";
var e1 = "'.L('try_other_lettres').'";
var e2 = "'.L('try_without_options').'";
var e3 = "'.L('All_categories').'";
var e4 = "'.L('Impossible').'";

function split( val ) { return val.split( "'.QTF_QUERY_SEPARATOR.'" ); }
function extractLast( term ) { return split( term ).pop().replace(/^\s+/g,"").replace(/\s+$/g,""); }

function Running()
{
  var doc = document;
  if ( doc.getElementById("ico_option") )
  {
  var running="option";
  if (doc.getElementById("s").value!="*" || doc.getElementById("st").value!="*") running="run";
  doc.getElementById("ico_option").src="'.$_SESSION[QT]['skin_dir'].'/ico_section_" + running + ".gif"
  }
}
function SearchOption(option,strValue)
{
  var doc = document;
  if (doc.getElementById(option+"ref")) doc.getElementById(option+"ref").value=strValue;
  if (doc.getElementById(option+"id")) doc.getElementById(option+"id").value=strValue;
  if (doc.getElementById(option+"kw")) doc.getElementById(option+"kw").value=strValue;
  if (doc.getElementById(option+"adv")) doc.getElementById(option+"adv").value=strValue;
  Running();
}
function ValidateForm(theForm)
{
  if ( theForm.id=="form_ref" ) if (document.getElementById("ref").value.length==0) { alert("Ref. - "+qtHtmldecode("'.$L['Missing'].'")); return false; }
  if ( theForm.id=="form_kw" ) if (document.getElementById("kw").value.length==0) { alert("Text - "+qtHtmldecode("'.$L['Missing'].'")); return false; }
  if ( theForm.id=="form_adv" )
  {
   if (document.getElementById("date").value.length==0) { alert("Date - "+qtHtmldecode("'.$L['Missing'].'")); return false; }
   if (document.getElementById("date").value.length==0) { alert("Date - "+qtHtmldecode("'.$L['Missing'].'")); return false; }
  }
  return null;
}
//-->
</script>
';
$oHtml->scripts_end[] = '<script type="text/javascript">
<!--
$(function() {

  $( "#kw" ).autocomplete({
      source: function(request, response) {
        $.ajax({
          url: "qtf_j_kw.php",
          dataType: "json",
          data: { term: extractLast( request.term ), s:function() { return $("#s").val(); }, st:function() { return $("#st").val(); }, v2:function() { return $("#to").is(":checked"); }, e0:e0, e1:e1, e2:e2 },
          success: function(data) { response(data); }
        });
      },
      search: function() {
        // custom minLength
        var term = extractLast( this.value );
        if ( term.length < 2 ) { return false; }
    },
      focus: function( event, ui ) { return false; },
      select: function( event, ui ) {
        var terms = split( this.value );
        terms.pop(); // remove current input
        terms.push( ui.item.rItem ); // add the selected item
        terms.push( "" ); // add placeholder to get the comma-and-space at the end
        this.value = terms.join( "'.QTF_QUERY_SEPARATOR.'" );
        return false;
      }
    })
    .data( "autocomplete" )._renderItem = function( ul, item ) {
      return $( "<li></li>" )
        .data( "item.autocomplete", item )
        .append( "<a class=\"jvalue\">" + item.rItem + (item.rInfo=="" ? "" : " &nbsp;<span class=\"jinfo\">(" + item.rInfo + ")</span>") + "</a>" )
        .appendTo( ul );
    };
  $( "#tag" ).autocomplete({
      source: function(request, response) {
        $.ajax({
          url: "qtf_j_tagsearch.php",
          dataType: "json",
          data: { term: extractLast( request.term ), s:function() { return $("#s").val(); }, st:function() { return $("#st").val(); }, ti:function() { return $("#ti").val(); }, y:function() { return $("#y").val(); }, e0:e0, e1:e1, e2:e2 },
          success: function(data) { response(data); }
        });
      },
      search: function() {
        // custom minLength
        var term = extractLast( this.value );
        if ( term.length < 2 ) { return false; }
    },
      focus: function( event, ui ) { return false; },
      select: function( event, ui ) {
        var terms = split( this.value );
        terms.pop(); // remove current input
        terms.push( ui.item.rItem ); // add the selected item
        terms.push( "" ); // add placeholder to get the comma-and-space at the end
        this.value = terms.join( "'.QTF_QUERY_SEPARATOR.'" );
        return false;
      }
    })
    .data( "autocomplete" )._renderItem = function( ul, item ) {
      return $( "<li></li>" )
        .data( "item.autocomplete", item )
        .append( "<a class=\"jvalue\">" + item.rItem + (item.rInfo=="" ? "" : " &nbsp;<span class=\"jinfo\">(" + item.rInfo + ")</span>") + "</a>" )
        .appendTo( ul );
    };
});
//-->
</script>
';

include 'qtf_p_header.php';
include 'qtf_usermenu.php';

// SEARCH OPTION

echo '<h2>',$L['Search_option'],'</h2>
<div class="searchoptions">
<form>
<p>
',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_option.gif','search',$L['Search'],'ico i_sec','','','ico_option'),'
',$L['Section'],'&nbsp;<select id="s" name="s" size="1" class="small" onchange="SearchOption(this.name,this.value);" style="width:150px">',Sectionlist($s,array(),array(),$L['In_all_sections']),'</select>
',$L['Status'],'&nbsp;<select id="st" name="st" size="1" class="small" onchange="SearchOption(this.name,this.value);">
<option value="*"',($st==='*' ? QSEL : ''),'>',$L['Any_status'],'</option>
',QTasTag(cTopic::GetStatuses(),$st),'
</select>
</p>
</form>
</div>
';

echo '
<h2>',$L['Search_criteria'],'</h2>
<!-- tab -->
<div class="pan">
<div class="searchcriteria">';

// ERROR MESSAGE

if ( !empty($error) ) echo '<p class="error">',$error,'</p>';

// SEARCH BY REF

if ( isset($oVIP) ) {
if ( count($_SESSION[QT]['sys_sections'])>0 ) { $arrSections = QTarrget(GetSections($oVIP->user->role,-1,-1,'s.numfield<>"N"'));
if ( count($arrSections)>0 ) {
echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(\'ref\');">
<table class="data_s">
<tr class="data_s">
<td class="tdicon">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>
<td>',$L['Ref'],' <input type="text" id="ref" name="v" size="5" maxlength="10" value="'.($q=='ref' ? $v : '').'"/>&nbsp;<label for="title">',$L['H_Reference'],'</label></td>
<td style="padding:7px; text-align:right">
<input type="hidden" name="q" value="ref"/>
<input type="hidden" id="s_ref" name="s_ref" value="',$s,'"/>
<input type="hidden" id="st_ref" name="st_ref" value="',$st,'"/>
<input type="submit" name="ok" value="',$L['Search'],'" onclick="return ValidateForm(\'ref\');"/>
</td>
</table>
</form>
';
}}}

// SEARCH BY KEY

echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(\'kw\');">
<table class="data_s">
<tr class="data_s">
<td class="tdicon">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>
<td >',$L['Keywords'],' <input type="text" id="kw" name="v" size="40" maxlength="64" value="'.($q=='kw' ? $v : '').'"/>*&nbsp;<input type="checkbox" id="to" name="v2"',(empty($v2) ? '' : QCHE),' value="1"/> <label for="to">',$L['In_title_only'],'</label>
</td>
<td  style="padding:7px; text-align:right">
<input type="hidden" name="q" value="kw"/>
<input type="hidden" id="s_kw" name="s_kw" value="',$s,'"/>
<input type="hidden" id="st_kw" name="st_kw" value="',$st,'"/>
<input type="submit" name="ok" value="',$L['Search'],'" onclick="return ValidateForm(\'kw\');"/>
</td>
</table>
</form>
';

// SEARCH BY DATE & TAGS

echo '<form method="post" action="',$oVIP->selfurl,'">
<table class="data_s">
<tr class="data_s">
<td class="tdicon">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>
<td>',$L['Date'],' <select id="ti" name="v2" size="1" class="small">
<option value="*"',($v2==='*' || $v2==='' ? QSEL : ''),'>',$L['Any_time'],'</option>
<optgroup label="&nbsp;">
<option value="w"',($v2==='w' ? QSEL : ''),'>',$L['This_week'],'</option>
<option value="m"',($v2==='m' ? QSEL : ''),'>',$L['This_month'],'</option>
<option value="y"',($v2==='y' ? QSEL : ''),'>',$L['This_year'],'</option>
</optgroup>
<optgroup label="&nbsp;">
',QTasTag($L['dateMMM'],(int)$v2),'
</optgroup>
</select><input type="hidden" id="y" name="y" value="',date('Y'),'"/>
';
if ( $_SESSION[QT]['tags']!='0' ) echo $L['With_tag'],' <input type="text" id="tag" name="v" size="30" value="'.($q=='adv' ? $v : '').'" class="small"/>*';
echo '</td>
<td  style="padding:7px; text-align:right">
<input type="hidden" name="q" value="adv"/>
<input type="hidden" id="s_adv" name="s_adv" value="',$s,'"/>
<input type="hidden" id="st_adv" name="st_adv" value="',$st,'"/>
<input type="submit" name="ok" value="',$L['Search'],'"/>
</td>
</tr>
</table>
</form>
';
if ( $_SESSION[QT]['tags']!='0' ) echo '<p class="small">* ',$L['H_Tag_input'],'</p>';

echo '
</div>
</div>
';

// HTML END

$oHtml_scripts_end[] = '<script type="text/javascript">
<!--
var doc = document;
qtFocusEnd("ref");
if ( doc.getElementById("kw") )
{
  if (!doc.getElementById("ref") || doc.getElementById("kw").value.length>0 ) qtFocusEnd("kw");
}
if ( doc.getElementById("tag") )
{
  if (doc.getElementById("tag").value.length>0) qtFocusEnd("tag");
}
Running();
//-->
</script>
';

include 'qtf_p_footer.php';