<?php
/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( !$oVIP->user->CanView('V4') ) HtmlPage(11);

$id = -1;
if ( isset($_GET['id']) ) $id = intval($_GET['id']);
if ( isset($_POST['id']) ) $id = intval($_POST['id']);
if ( isset($_GET['edit']) ) $_SESSION[QT]['editing']=($_GET['edit']=='1' ? true : false);
if ( isset($_POST['edit']) ) $_SESSION[QT]['editing']=($_POST['edit']=='1' ? true : false);
if ( $id<0 ) die('Wrong id');

// --------
// FUNCTION
// --------

function show_ban($strRole='V',$intBan=0,$name='')
{
  if ( $intBan<1 ) return '';
  if ( $strRole=='A' || $strRole=='M' )
  {
    if ( $intBan>1 ) $intBan=($intBan-1)*10;
    Return '<p class="small error">'.$name.' '.strtolower(L('Is_banned').' '.L('Day',$intBan).' '.L('Since').' '.L('Last_message')).'</p>';
  }
}

// ------
// INITIALISE
// --------

include 'bin/class/qt_class_smtp.php';
include Translate('qtf_reg.php');

$bCanEdit = false;
if ( $oVIP->user->id==$id ) $bCanEdit=true;
if ( $oVIP->user->IsStaff() ) $bCanEdit=true;
if ( $id==0 ) $bCanEdit=false;
if ( !isset($_SESSION[QT]['editing']) || !$bCanEdit) $_SESSION[QT]['editing']=false;

$oVIP->selfurl = 'qtf_user.php';
$oVIP->selfname = $L['Profile'];

// MAP MODULE

$bMap=false;
if ( UseModule('map') )
{
  include Translate('qtfm_map.php');
  include 'qtfm_map_lib.php';
  if ( QTgcanmap('U') ) $bMap=true;
  if ( $bMap )
  {
  $oHtml->links[]='<link rel="stylesheet" type="text/css" href="qtfm_map.css" />';
  if ( !isset($_SESSION[QT]['m_map_symbols']) ) $_SESSION[QT]['m_map_symbols']='0';
  $arrSymbolByRole = ( empty($_SESSION[QT]['m_map_symbols']) ? array() : QTexplode($_SESSION[QT]['m_map_symbols']) );
  }
}

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check form

  $strLoca = trim($_POST['location']); if ( get_magic_quotes_gpc() ) $strLoca = stripslashes($strLoca);
  $strLoca = QTconv($strLoca,'3',QTF_CONVERT_AMP);

  if ( empty($error) )
  {
    $strMail = trim($_POST['mail']);
    $strMail = str_replace(';',' ; ',$strMail);
    $strMail = str_replace('  ',' ',$strMail);
    if ( !empty($strMail) && !QTismail($strMail) ) $error=$L['Email'].' '.$strMail.' '.$L['E_invalid'];
  }

  if ( empty($error) )
  {
    if ( empty($_POST['birth_y']) || empty($_POST['birth_d']) || empty($_POST['birth_d']) )
    {
      $strBirth = '0';
    }
    else
    {
      $i = intval($_POST['birth_y'])*10000+intval($_POST['birth_m'])*100+intval($_POST['birth_d']);
      if ( !QTisvaliddate($i,true,false,false) ) $error = $L['Birthday'].' ('.$_POST['birth_y'].'-'.$_POST['birth_m'].'-'.$_POST['birth_d'].') '.$L['E_invalid'];
      $strBirth = $i;
    }
  }

  if ( empty($error) )
  {
    if ( isset($_POST['child']) ) { $strChild = substr($_POST['child'],0,1); } else { $strChild = '0'; }
    if ( $id==1 && $strChild!='0' ) $error='user id[1] is admin and child status cannot be changed...';
    if ( $id==0 && $strChild!='0' ) $error='user id[0] is visitor and child status cannot be changed...';
  }

  if ( empty($error) )
  {
    if ( isset($_POST['parentmail']) ) { $strParentmail = trim($_POST['parentmail']); } else { $strParentmail=''; }
    if ( !empty($strParentmail) ) { if ( !QTismail($strParentmail) ) $error=$L['Parent_mail'].' '.$L['E_invalid']; }
  }

  if ( empty($error) )
  {
    $strWww = QTconv($_POST['www'],'2');
    if ( !empty($strWww) && substr($strWww,0,4)!='http' ) $error=$L['Website'].' '.$L['E_invalid'];
    if ( $strWww=='http://' || $strWww=='https://' ) $strWww='';
  }

  // Save

  if ( empty($error) )
  {
    $oDB->Query('UPDATE '.TABUSER.' SET birthday="'.$strBirth.'",location="'.addslashes($strLoca).'", mail="'.$strMail.'", www="'.addslashes($strWww).'", privacy="'.$_POST['privacy'].'", children="'.$strChild.'", parentmail="'.$strParentmail.'" WHERE id='.$id);
    if ( isset($_POST['coord']) )
    {
      $coord = strip_tags(trim($_POST['coord']));
      $coord = str_replace(' ','',$coord); // remove spaces between coordinates y,x
      cUser::SetCoord($id,$coord); // coord can be empty (coordinates are removed)
    }

    // parent warning if coppa

    if ( $strChild=='1' ) {
    if ( $_SESSION[QT]['register_coppa']=='1' ) {
      $strSubject='Profile updated';
      $strMessage="Your children (login: %s) has modified his/her profile on the board {$_SESSION[QT]['site_name']}.";
      $strFile = GetLang().'mail_profile_coppa.php';
      if ( file_exists($strFile) ) include $strFile;
      $strMessage = sprintf($strMessage, $_POST['name']);
      QTmail($_POST['parentmail'],$strSubject,$strMessage,QTF_HTML_CHAR);
    }}

    // exit (if no error)

    $oVIP->exiturl = 'qtf_user.php?id='.$id;
    $oVIP->exitname = $L['Profile'];
    $_SESSION['pagedialog'] = 'O|'.$L['S_update'];
    $oHtml->Redirect($oVIP->exiturl);
  }
  else
  {
    $_SESSION['pagedialog'] = 'E|'.$error;
  }
}

// --------
// STATS AND USER
// --------

// COUNT TOPICS

$oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE firstpostuser='.$id);
$row = $oDB->Getrow();
$items = $row['countid'];

// COUNT MESSAGES

$oDB->Query('SELECT count(id) as countid FROM '.TABPOST.' WHERE userid='.$id);
$row = $oDB->Getrow();
$countmessages = $row['countid'];

// QUERY USER

$oDB->Query('SELECT * FROM '.TABUSER.' WHERE id='.$id);
$row = $oDB->Getrow();
$row['name'] = QTconv($row['name'],'5');
$row['privacy']= (int)$row['privacy'];

  // check privacy
  if ( $oVIP->IsPrivate($row['privacy'],$id) ) { $row['y']=null; $row['x']=null; }

  // staff cannot edit other staff nor admin
  if ( $row['role']=='M' && $oVIP->user->role=='M' && !QTF_STAFFEDITSTAFF && $oVIP->user->id!=$id ) { $bCanEdit=false; $_SESSION[QT]['editing']=false; }
  if ( $row['role']=='A' && $oVIP->user->role=='M' && !QTF_STAFFEDITADMIN ) { $bCanEdit=false; $_SESSION[QT]['editing']=false; }

  // map settings
  if ( $bMap && !QTgempty($row['x']) && !QTgempty($row['y']) )
  {
    $y = (float)$row['y']; $x = (float)$row['x'];
    $strPname = QTconv($row['name'],'U');
    $oMapPoint = new cMapPoint($y,$x,$strPname);
    if ( !empty($arrSymbolByRole[$row['role']]) ) $oMapPoint->icon = $arrSymbolByRole[$row['role']];
    $arrExtData[$id] = $oMapPoint;
  }

// DEFAULT

if ( empty($row['picture']) )
{
$strUserImage = '<img src="'.$_SESSION[QT]['skin_dir'].'/user.gif" title="'.$row['name'].'" alt="(user)">';
}
else
{
$strUserImage = AsImg(QTF_DIR_PIC.$row['picture'],'',$row['name']);
}

$strMail = '';  if ( !empty($row['mail']) && !$oVIP->IsPrivate($row['privacy'],$id) ) $strMail = AsEmails($row['mail'],$id,0,'txt'.(QTF_JAVA_MAIL ? 'java' : ''),false,$_SESSION[QT]['skin_dir'],$L['E_javamail']);
$strLocation = ''; if ( !empty($row['location']) && !$oVIP->IsPrivate($row['privacy'],$id) ) $strLocation = $row['location'];
$strCoord = ''; // coordinates with visual units
$strYX = ''; // coordinates in map unit [y,x]
if ( $bMap && !empty($row['x']) && !empty($row['y']) && !$oVIP->IsPrivate($row['privacy'],$id) )
{
  $strYX = round((float)$row['y'],8).','.round((float)$row['x'],8);
  $strCoord = QTdd2dms((float)$row['y']).', '.QTdd2dms((float)$row['x']).' '.$L['Coord_latlon'].' <span class="small disabled">DD '.$strYX.'</span>';
}
$strPriv = '';  if ( $row['privacy']!=2 && ($oVIP->user->IsStaff() || $oVIP->user->id==$id) ) $strPriv=' <img class="ico" src="admin/private'.$row['privacy'].'.gif" title="'.$L['Privacy_visible_'.$row['privacy']].'"/>';

// --------
// HTML START
// --------

include 'qtf_p_header.php';

if ( $id<0 )  die('Wrong id in qtf_user.php');

// -- PARTICIPATION INFO --

$strParticip = '';
if ( $items>0 )
{
$strParticip .= '<a href="qtf_items.php?q=user&amp;v='.$id.'&amp;v2='.urlencode($row['name']).'">'.L('Item',$items).'</a>, ';
}
if ( $countmessages>0 )
{
  $strParticip .= L('Message',$countmessages).', '.strtolower($L['Last_message']).' '.QTdatestr($row['lastdate'],'$','$',true);
  $oDB->Query( 'SELECT p.id,p.topic,p.forum FROM '.TABPOST.' p WHERE p.userid='.$id.' ORDER BY p.issuedate DESC' );
  $row2 = $oDB->Getrow();
  $strParticip .= ' <a href="qtf_item.php?t='.$row2['topic'].'&amp;tt=messages#p'.$row2['id'].'" title="'.$L['H_Goto_message'].'">'.$L['Goto_message'].'</a>';
}

// -- USER MENU --

include 'qtf_usermenu.php';

// -- DISPLAY PROFILE --

echo '<h2>',$oVIP->selfname,'</h2>
<table class="hidden">
<tr class="hidden">
<td class="hidden profileleft">
';

echo AsImgBox($strUserImage,'picbox','',$row['name']);

if ( CanPerform('show_calendar',$oVIP->user->role) )
{
echo '<p><a href="',Href('qtf_calendar.php'),(empty($row['birthday']) ? '' : '?m='.substr($row['birthday'],4,2)).'">'.$L['Birthdays_calendar'].'</a></p>';
echo '<hr/>';
}
if ( $bCanEdit )
{
  if ( $_SESSION[QT]['avatar']!='0' )
  {
  echo '<p><a href="',Href('qtf_user_img.php'),'?id=',$id,'">',$L['Change_picture'],'</a></p>';
  }
  echo '<p><a href="',Href('qtf_user_sign.php'),'?id=',$id,'">',$L['Change_signature'],'</a></p>';
  echo '<p><a href="',Href('qtf_user_pwd_chg.php'),'?id=',$id,'">',$L['Change_password'],'</a></p>';
  echo '<p><a href="',Href('qtf_user_question.php'),'?id=',$id,'">',$L['Secret_question'],'</a></p>';
}
if ( !empty($row['closed']) ) echo '<hr/>',show_ban($oVIP->user->role,$row['closed'],$row['name']);

echo '</td>
<td class="hidden profileright">
<div class="userprofile">
';

// -- EDIT PROFILE --
if ( $_SESSION[QT]['editing'] ) {
// -- EDIT PROFILE --

echo '<form method="post" action="',Href('qtf_user.php'),'?id=',$id,'">
<table class="data_o">
<tr class="data_o"><td class="headfirst">',$L['Username'],'</td><td><span class="bold">',$row['name'],'</span> ';
if ( $oVIP->user->role=='A' || ($oVIP->user->id==$id && QTF_CHANGE_USERNAME) ) {
if ( $id>1 ) {
  echo ' &middot; <a class="small" href="qtf_user_rename.php?id=',$id,'">',$L['Change_name'],'</a>';
}}
echo '</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Role'],'</td><td>',$L['Userrole_'.$row['role']],'</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Location'],'</td><td><input type="text" name="location" size="35" maxlength="24" value="',$row['location'],'"/></td></tr>
<tr class="data_o"><td class="headfirst">',$L['Email'],'</td><td><input type="email" name="mail" size="35" maxlength="64" value="',$row['mail'],'"/></td></tr>
<tr class="data_o"><td class="headfirst">',$L['Website'],'</td><td><input type="text" name="www" pattern="^(http://|https://).*" size="35" maxlength="64" value="',( !empty($row['www']) ? $row['www'] : 'http://' ),'" title="',$L['H_Website'],'"/></td></tr>
<tr class="data_o"><td class="headfirst">',$L['Birthday'],'</td>
';
$strBrith_y = '';
$strBrith_m = '';
$strBrith_d = '';
if ( !empty($row['birthday']) )
{
  $strBrith_y = intval(substr(strval($row['birthday']),0,4));
  $strBrith_m = intval(substr(strval($row['birthday']),4,2));
  $strBrith_d = intval(substr(strval($row['birthday']),6,2));
}
echo '<td><select name="birth_d" size="1">',PHP_EOL;
echo QTasTag(array(0=>'',1=>1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31),$strBrith_d);
echo '</select>',PHP_EOL;
echo '<select name="birth_m" size="1">',PHP_EOL;
echo '<option value="0"></option>',QTasTag($L['dateMMM'],$strBrith_m);
echo '</select>',PHP_EOL;
echo '<input type="text" id="birth_y" name="birth_y" pattern="(19|20)[0-9]{2}" size="4" maxlength="4" value="',$strBrith_y,'"/></td>';
echo '</tr>',PHP_EOL;
if ( $oVIP->user->role=='A' && $id>1 )
{
  if ( $_SESSION[QT]['register_coppa']=='1' )
  {
  echo '<tr class="data_o">',PHP_EOL;
  echo '<td class="headfirst">',$L['Child'],'</td>';
  echo '<td>';
  echo '<select size="1" name="child">';
  echo '<option value="0"',($row['children']=='0' ? QSEL : ''),'>',$L['N'],'</option>';
  echo '<option value="1"',($row['children']=='1' ? QSEL : ''),'>',$L['Y'],' ',$L['With_parent_agree'],'</option>';
  echo '<option value="2"',($row['children']=='2' ? QSEL : ''),'>',$L['Y'],' ',$L['Without_parent_agree'],'</option>';
  echo '</select>';
  echo '</td>';
  echo '</tr>',PHP_EOL;
  echo '<tr class="data_o">';
  echo '<td class="headfirst">',$L['Parent_mail'],'</td>';
  echo '<td><input type="email" name="parentmail" size="32" maxlength="64" value="',$row['parentmail'],'"/></td>';
  echo '</tr>',PHP_EOL;
  }
}

echo '<tr class="data_o">
<td class="headfirst">',$L['Privacy'],'</td>
<td>',$L['Email'],'/',$L['Location'],($bMap ? '/'.$L['map']['position'] : ''),' <select size="1" name="privacy">
<option value="2"',($row['privacy']=='2' ? QSEL : ''),'>',$L['Privacy_visible_2'],'</option>
<option value="1"',($row['privacy']=='1' ? QSEL : ''),'>',$L['Privacy_visible_1'],'</option>
<option value="0"',($row['privacy']=='0' ? QSEL : ''),'>',$L['Privacy_visible_0'],'</option>
</select></td>
</tr>
';

if ( $bMap )
{
  $strPosition  = '<p class="small commands" style="margin:2px 0 4px 2px;text-align:right">'.$L['map']['cancreate'];
  if ( !empty($row['x']) && !empty($row['y']) )
  {
    $_SESSION[QT]['m_map_gcenter'] = $strYX;
    $strPosition  = '<p class="small commands" style="margin:2px 0 4px 2px;text-align:right">'.$L['map']['canmove'];
  }
  $strPosition .= ' | <a class="small" href="javascript:void(0)" onclick="createMarker(); return false;" title="'.$L['map']['H_pntadd'].'">'.$L['map']['pntadd'].'</a>';
  $strPosition .= ' | <a class="small" href="javascript:void(0)" onclick="deleteMarker(); return false;">'.$L['map']['pntdelete'].'</a>';
  $strPosition .= '</p>'.PHP_EOL;
  $strPosition .= '<div id="map_canvas"></div>'.PHP_EOL;
  $strPosition .= '<p class="small commands" style="margin:4px 0 2px 2px;text-align:right">'.$L['map']['addrlatlng'].' ';
  $strPosition .= '<input type="text" size="24" id="find" name="find" class="small" value="'.$_SESSION[QT]['m_map_gfind'].'" title="'.$L['map']['H_addrlatlng'].'" onkeypress="enterkeyPressed=qtKeyEnter(event); if (enterkeyPressed) showLocation(this.value,null);"/>';
  $strPosition .= '<img id="findit" src="qtfm_map_find.png" onclick="showLocation(document.getElementById(\'find\').value,null);" style="margin:0 0 0 2px;padding:2px;vertical-align:middle;width:16px;height:16px;border:solid 1px #cccccc;border-radius:3px;cursor:pointer" title="'.L('Search').'"/>';

  echo '<tr class="data_o">',PHP_EOL;
  echo '<td class="headfirst">',$L['Coord'],'</td>';
  echo '<td><input type="text" id="yx" name="coord" pattern="^\-?\d{1,2}(\.\d{1,10})? ?, ?\-?\d{1,3}(\.\d{1,10})?" size="32" value="'.$strYX.'" title="y,x in decimal degree (without trailing spaces)"/> <span class="small">',$L['Coord_latlon'],'</span></td>';
  echo '</tr>',PHP_EOL;
}

echo '<tr class="data_o">
<td class="headfirst"><input type="hidden" name="id" value="',$id,'"/><input type="hidden" name="name" value="',$row['name'],'"/></td>
<td><input type="submit" name="ok" value="',$L['Save'],'"/>',( !empty($error) ? ' <span class="error">'.$error.'</span>' : '' ),'</td>
</tr>
';

if ( $bMap )
{
echo '<tr class="data_o">
<td colspan="2">',$strPosition,'</td>
</tr>
';
}

echo '
</table>
</form>
';

// ------
} else {
// ------

echo '
<table class="data_o">
<tr class="data_o"><td class="headfirst">',$L['Username'],'</td><td><span class="bold">',$row['name'],'</span>';
if ( $oVIP->user->role=='A' || ($oVIP->user->id==$id && QTF_CHANGE_USERNAME) ) {
if ( $id>1 ) {
  echo ' &middot; <a class="small" href="qtf_user_rename.php?id=',$id,'">',$L['Change_name'],'</a>';
}}
echo '</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Role'],'</td><td>',$L['Userrole_'.$row['role']],'</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Location'],'</td><td>',$strLocation,'&nbsp;',$strPriv,'</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Email'],'</td><td>',$strMail,'&nbsp;',$strPriv,'</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Website'],'</td><td>',( empty($row['www']) ? '&nbsp;' : '<a href="'.$row['www'].'" target="_blank">'.$row['www'].'</a>' ),'</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Birthday'],'</td><td>'.(empty($row['birthday']) ? '&nbsp;' : QTdatestr($row['birthday'],'$','')).'</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Joined'],'</td><td>',QTdatestr($row['firstdate'],'$','$',true),'</td></tr>
<tr class="data_o"><td class="headfirst">',$L['Messages'],'</td><td>',$strParticip,'</td></tr>
';

if ( !$_SESSION[QT]['editing'] ) {
if ( $oVIP->user->id==$id || $oVIP->user->IsStaff() ) {
  echo '<tr class="data_o"><td class="headfirst">',$L['Privacy'],'</td><td>',$L['Email'],'/',$L['Location'],($bMap ? '/'.$L['map']['position'] : ''),' ',$L['Privacy_visible_'.$row['privacy']],' ',$strPriv,'</td></tr>';
}}

if ( $bMap ) {
if ( !empty($row['x']) && !empty($row['y']) ) {

  $strPlink = '<a href="http://maps.google.com?q='.$row['y'].','.$row['x'].'+('.urlencode($row['name']).')" class="small" title="'.$L['map']['In_google'].'" target="_blank">[G]</a>';
  $strPosition = '<div id="map_canvas" style="width:100%; height:350px;"></div>';
  echo '<tr class="data_o"><td class="headfirst">',$L['Coord'],'</td><td>',$strCoord,' ',$strPlink,$strPriv,'</td></tr>',PHP_EOL;
  echo '<tr class="data_o"><td colspan="2">',$strPosition,'</td></tr>',PHP_EOL;

}}

echo '</table>
';

// ------
}
// ------

echo '
</div>
</td>
</tr>
</table>
';

// --------
// HTML END
// --------

// MAP MODULE

if ( $bMap )
{
  $gmap_shadow = false;
  $gmap_symbol = false;
  if ( !empty($_SESSION[QT]['m_map_gsymbol']) )
  {
    $arr = explode(' ',$_SESSION[QT]['m_map_gsymbol']);
    $gmap_symbol=$arr[0];
    if ( isset($arr[1]) ) $gmap_shadow=$arr[1];
  }

  // check new map center
  $y = (float)QTgety($_SESSION[QT]['m_map_gcenter']);
  $x = (float)QTgetx($_SESSION[QT]['m_map_gcenter']);

  // First item is the user's location and symbol
  if ( isset($arrExtData[$id]) )
  {
    // symbol by role
    $oMapPoint = $arrExtData[$id];
    if ( !empty($oMapPoint->icon) ) $gmap_symbol = $oMapPoint->icon;
    if ( !empty($oMapPoint->shadow) ) $gmap_shadow = $oMapPoint->shadow;

    // center on user
    if ( !empty($oMapPoint->y) && !empty($oMapPoint->x) )
    {
    $y=$oMapPoint->y;
    $x=$oMapPoint->x;
    }
  }

  // update center
  $_SESSION[QT]['m_map_gcenter'] = $y.','.$x;

  $gmap_markers = array();
  $gmap_events = array();
  $gmap_functions = array();
  if ( isset($arrExtData[$id]) && !empty($oMapPoint->y) && !empty($oMapPoint->x) )
  {
    $gmap_markers[] = QTgmapMarker($oMapPoint->y.','.$oMapPoint->x,true,$gmap_symbol,$row['name'],'',$gmap_shadow);
  }
  $gmap_events[] = '
	google.maps.event.addListener(markers[0], "position_changed", function() {
		if (document.getElementById("yx")) {document.getElementById("yx").value = gmapRound(marker.getPosition().lat(),10) + "," + gmapRound(marker.getPosition().lng(),10);}
	});
	google.maps.event.addListener(marker[0], "dragend", function() {
		map.panTo(marker.getPosition());
	});';
  $gmap_functions[] = '
  function showLocation(address,title)
  {
    if ( infowindow ) infowindow.close();
    geocoder.geocode( { "address": address}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK)
      {
        map.setCenter(results[0].geometry.location);
        if ( markers[0] )
        {
          markers[0].setPosition(results[0].geometry.location);
        } else {
          markers[0] = new google.maps.Marker({map: map, position: results[0].geometry.location, draggable: true, animation: google.maps.Animation.DROP, title: title});
        }
        gmapYXfield("yx",markers[0]);
      } else {
        alert("Geocode was not successful for the following reason: " + status);
      }
    });
  }
  function createMarker()
  {
    if ( !map ) return;
    if (infowindow) infowindow.close();
    deleteMarker();
    '.QTgmapMarker('map',true,$gmap_symbol).'
    gmapYXfield("yx",markers[0]);
    google.maps.event.addListener(markers[0], "position_changed", function() { gmapYXfield("yx",markers[0]); });
    google.maps.event.addListener(markers[0], "dragend", function() { map.panTo(markers[0].getPosition()); });
  }
  function deleteMarker()
  {
    if (infowindow) infowindow.close();
    for(var i=markers.length-1;i>=0;i--)
    {
      markers[i].setMap(null);
    }
    gmapYXfield("yx",null);
    markers=[];
  }
  ';
  include 'qtfm_map_load.php';
}

include 'qtf_p_footer.php';