<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( !$oVIP->user->CanView('V0') ) HtmlPage(11);

// INITIALISE

include Translate('qtf_reg.php');
$intY = ''; // no year at start-up
$intM = 1;
$intD = 1;
if ( isset($_GET['y']) ) { $intY = intval($_GET['y']); }
if ( isset($_GET['m']) ) { $intM = intval($_GET['m']); }
if ( isset($_GET['d']) ) { $intD = intval($_GET['d']); }
if ( isset($_POST['y']) ) { $intY = intval(strip_tags($_POST['y'])); }
if ( isset($_POST['m']) ) { $intM = intval(strip_tags($_POST['m'])); }
if ( isset($_POST['d']) ) { $intD = intval(strip_tags($_POST['d'])); }

$oVIP->selfurl = 'qtf_user_new.php';
$oVIP->selfname = $L['Register'];
$oVIP->exiturl = $oVIP->selfurl.'?y='.$intY.'&amp;m='.$intM.'&amp;d='.$intD;
$oVIP->exitname = '&laquo;'.' '.$L['Register'];

// --------
// EXECUTE FORM
// --------

if ( isset($_POST['ok']) )
{
  if ( !isset($_POST['agreed']) ) $oHtml->PageBox($oVIP->selfname,L('Rules_not_agreed'),$_SESSION[QT]['skin_dir'],0,'400px'); // exit

  if ( !QTisvaliddate($intY*10000+$intM*100+$intD,true,false,false) ) $error = $L['Birthday'].' '.$L['E_invalid'];

  if ( empty($error) ) $oHtml->Redirect('qtf_form_reg.php?y='.$intY.'&amp;m='.$intM,'&amp;d='.$intD);
  $_SESSION['pagedialog'] = 'E|'.$error;
}

// --------
// HTML START
// --------

$oHtml->scripts[] = '<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.y.value.length!=4) { alert(qtHtmldecode("'.$L['E_mandatory'].': '.$L['Year'].' (yyyy)")); return false; }
  return null;
}
//-->
</script>
';

include 'qtf_p_header.php';

echo '<form method="post" action="',Href($oVIP->selfurl),'" onsubmit="return ValidateForm(this);">',PHP_EOL;
echo '<div class="scrollmessage">',PHP_EOL;

$strFile = GetLang().'sys_rules.txt';
if (file_exists($strFile)) { include $strFile; } else { echo 'Missing file:<br/>',$strFile; }

echo '</div>',PHP_EOL;
echo '<p><input type="checkbox" id="agreed" name="agreed"',(isset($_POST['agreed']) ? QCHE : ''),'/><label for="agreed"><b>&nbsp;',$L['Agree'],'</b></label></p>',PHP_EOL;

$oHtml->Msgbox($oVIP->selfname,'msgbox abide');

echo '<p><label for="y">',$L['Birthday'],'</label></p><p>';
echo '<select name="d" size="1">',PHP_EOL;
echo QTasTag(array(1=>1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31),$intD);
echo '</select>',PHP_EOL;
echo '<select name="m" size="1">',PHP_EOL;
echo QTasTag($L['dateMMM'],$intM);
echo '</select>',PHP_EOL;
echo '<input type="text" id="y" name="y" size="4" maxlength="4" pattern="(19|20)[0-9]{2}" value="',(empty($intY) ? '' : $intY),'"/>';
echo '</p><p><input type="submit" name="ok" value="',$L['Register'],'"/></p>';

$oHtml->Msgbox(END);

echo'
</form>
';

// HTML END

include 'qtf_p_footer.php';