<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    QuickTalk
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2012 The PHP Group
 * @version    3.0 build:20121228
 */

session_start();
require_once 'bin/qtf_init.php';
$oHtml->links['css'] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtf_index.css" /><link rel="stylesheet" type="text/css" href="bin/css/qtf_print.css" media="print" />';
if ( !$oVIP->user->CanView('U') ) die(Error(11));

// --------
// INITIALISE
// --------

$id = -1;
if (isset($_GET['id'])) $id = intval(strip_tags($_GET['id']));
if (isset($_POST['id'])) $id = intval(strip_tags($_POST['id']));
if ($id<0) die('Missing parameters');

include 'bin/class/qt_class_smtp.php';
include Translate('qtf_reg.php');

$oDB->Query('SELECT * FROM '.TABUSER.' WHERE id='.$id);
$row = $oDB->Getrow();

$oVIP->selfurl = 'qtf_user_rename.php';
$oVIP->selfname = $L['Change_name'];
$oVIP->exiturl = 'qtf_user.php?id='.$id;
$oVIP->exitname = '&laquo; '.$L['Profile'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check name
  if ( empty($error) )
  {
    $strName = trim(strip_tags($_POST['title'])); if ( get_magic_quotes_gpc() ) $strName = stripslashes($strName);
    if ( !QTislogin($strName) ) $error = $L['E_invalid'];
    if ( empty($error) )
    {
    $oDB->Query('SELECT count(*) as countid FROM '.TABUSER.' WHERE name="'.$strName.'"');
    $row = $oDB->Getrow();
    if ( $row['countid']!=0 ) $error = $L['E_already_used'];
    }
  }

  // execute and exit
  if ( empty($error) )
  {
    $oDB->Query('UPDATE '.TABUSER.' SET name="'.$strName.'" WHERE id='.$id);
    // Post
    $oDB->query('UPDATE '.TABPOST.' SET username="'.$strName.'" WHERE userid='.$id);
    $oDB->query('UPDATE '.TABPOST.' SET modifname="'.$strName.'" WHERE modifuser='.$id);
    $oDB->query('UPDATE '.TABTOPIC.' SET firstpostname="'.$strName.'" WHERE firstpostuser='.$id);
    $oDB->query('UPDATE '.TABTOPIC.' SET lastpostname="'.$strName.'" WHERE lastpostuser='.$id);
    $oDB->query('UPDATE '.TABSECTION.' SET moderatorname="'.$strName.'" WHERE moderator='.$id);

    $oVIP->exiturl = 'qtf_login.php?dfltname='.$strName;
    $oVIP->exitname = '&laquo; '.$L['Login'];
    $oHtml->PageBox(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  }
}

// DEFAULT

if ( empty($row['picture']) )
{
$strUserImage = '<img src="'.$_SESSION[QT]['skin_dir'].'/user.gif" title="'.$row['name'].'" alt="(user)">';
}
else
{
$strUserImage = AsImg(QTF_DIR_PIC.$row['picture'],'',$row['name']);
}

// --------
// HTML START
// --------

$oHtml->scripts[] = '<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(html_entity_decode("'.$L['E_mandatory'].': '.$L['Username'].'")); return false; }
  return null;
}
//-->
</script>
';
$oHtml->scripts_end[] = '<script type="text/javascript">
<!--
$(function() {
  $("#title").keyup(function() {
    document.getElementById("title_err").innerHTML="&nbsp;";
    document.getElementById("DoRename").disabled=false;
    $.post("qtf_j_exists.php",
      {f:"name",v:$("#title").val(),e1:"'.L('E_already_used').'"},
      function(data) { if ( data.length>0 ) {document.getElementById("title_err").innerHTML=data;document.getElementById("DoRename").disabled=true;} });
  });
});
//-->
</script>
';

include 'qtf_p_header.php';

if ( !empty($error) ) echo '<p id="infomessage" class="error">',$error,'</p>';

echo '
<table class="hidden">
<tr class="hidden">
<td class="hidden" style="width:175px;">',AsImgBox($strUserImage,'picbox','',$row['name']),'</td>
<td class="hidden">
';

$oHtml->Msgbox($oVIP->selfname,'msgbox login,msgboxtitle login,msgboxbody login');

echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<input type="hidden" name="id" value="',$id,'"/>
<h2>',$row['name'],'</h2>
<p>',$L['Choose_name'],'</p>
<p><input type="text" id="title" name="title" pattern="^.{2}.*" title="'.sprintf(L('E_char_min'),2).'" size="20" maxlength="32"/></p>
<p><span id="title_err" class="error">&nbsp;</span> <input type="submit" id="DoRename" name="ok" value="',$L['Save'],'"/></p>
</form>
';

$oHtml->Msgbox(END);

echo '
</td>
</tr>
</table>
<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>
';

// --------
// HTML END
// --------

include 'qtf_p_footer.php';