<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( !$oVIP->user->CanView('U',true) ) die(Error(11));

// INITIALISE

include Translate('qtf_reg.php');

$id = -1;
if ( isset($_GET['id']) ) $id = intval(strip_tags($_GET['id']));
if ( isset($_POST['id']) ) $id = intval(strip_tags($_POST['id']));
if ( $id<0 ) die('Missing parameters');
if ( $oVIP->user->role!='A' && $oVIP->user->id!=$id ) die($L['R_member']);

$oVIP->selfurl = 'qtf_user_sign.php';
$oVIP->selfname = $L['Change_signature'];
$oVIP->exiturl = 'qtf_user.php?id='.$id;
$oVIP->exitname = '&laquo; '.$L['Profile'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check values and protect against injection
  $str = trim($_POST['text']); if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
  $str = substr( QTconv($str,'3',QTF_CONVERT_AMP),0,255 );

  // update user
  if ( empty($error) )
  {
    $oDB->Query('UPDATE '.TABUSER.' SET signature="'.$str.'" WHERE id='.$id);
    // exit
    $_SESSION['pagedialog'] = 'O|'.$L['S_update'];
    $oHtml->Redirect($oVIP->exiturl);
  }
}

// DEFAULT

$oDB->Query('SELECT signature,name,picture FROM '.TABUSER.' WHERE id='.$id);
$row = $oDB->Getrow(); if ( !is_string($row['signature']) ) $row['signature']='';

if ( empty($row['picture']) )
{
$strUserImage = '<img src="'.$_SESSION[QT]['skin_dir'].'/user.gif" title="'.$row['name'].'" alt="(user)">';
}
else
{
$strUserImage = AsImg(QTF_DIR_PIC.$row['picture'],'',$row['name']);
}

// --------
// HTML START
// --------

$intBbc=3;
if ( $_SESSION[QT]['bbc']!='0' )
{
$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="bin/css/qtf_bbc.css" />';
$oHtml->scripts[] = '<script type="text/javascript" src="bin/js/qtf_bbc.js"></script>';
}

include 'qtf_p_header.php';

if ( $oVIP->user->role!='A' && $oVIP->user->id!=$id ) die($L['R_member']);

$strSign = QTbbc($row['signature']);
if ( empty($strSign) ) $strSign='&nbsp;';

echo '<table class="hidden">
<tr class="hidden">
<td class="hidden" style="width:175px"><br/>',AsImgBox($strUserImage,'picbox','',$row['name']),'</td>
<td class="hidden">
';

// SIGNATURE

echo '<h2>',$L['Signature'],'</h2>
<table class="data_o">
<tr class="tr_o">
<td>',$strSign,'</td>
</tr>
</table>
<p>',$L['H_no_signature'],'</p>
';

// NEW SIGNATURE

echo '
<h2>',$oVIP->selfname,'</h2>
<form method="post" action="',$oVIP->selfurl,'">
<table class="data_o">
<tr class="data_o">
<td>
';
if ( $_SESSION[QT]['bbc']=='1' )
{
  echo '<ul class="inline bbc">',PHP_EOL;
  include 'qtf_form_button.php';
  echo '</ul>',PHP_EOL;
}
echo '<div><a id="textarea"></a><textarea id="text" name="text" rows="5" cols="75">',$row['signature'],'</textarea></div>',PHP_EOL;
echo '</td>
</tr>
<tr class="data_o">
<td>
<input type="hidden" name="id" value="',$id,'"/>
<input type="submit" name="ok" value="',$L['Save'],'"/>',( !empty($error) ? ' <span class="error">'.$error.'</span>' : ''),'</td>
</tr>
</table>
</form>
<p><a href="',Href($oVIP->exiturl),'">',$oVIP->exitname,'</a></p>
';

echo '
</td>
</tr>
</table>
';

// HTML END

include 'qtf_p_footer.php';