<?php
/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( !$oVIP->user->CanView('V5') ) HtmlPage(11);

// CHANGE USER INTERFACE

if (isset($_GET['view'])) $_SESSION[QT]['viewmode'] = substr($_GET['view'],0,1);

// INITIALISE

include 'bin/qtf_fn_sql.php';

// Protection against injection: 'order','group','dir' are controlled
$strGroup = 'all';
$strOrder = 'name';
$strDirec = 'ASC';
$intLimit = 0;
$intPage  = 1;
if ( isset($_GET['group']) ) { $strGroup = substr($_GET['group'],0,3); } // protection against injection
if ( isset($_GET['page']) )  { $intLimit = (intval($_GET['page'])-1)*$_SESSION[QT]['items_per_page']; $intPage = intval($_GET['page']); }
if ( isset($_GET['order']) ) { $strOrder = strip_tags(substr($_GET['order'],0,15)); } // protection against injection
if ( isset($_GET['dir']) )   { if ( strtoupper($_GET['dir'])=='DESC' ) $strDirec = 'DESC'; } // protection against injection

$oVIP->selfurl = 'qtf_users.php';
$oVIP->selfname = $L['Memberlist'];

// MAP MODULE

$bMap=false;
if ( UseModule('map') )
{
  include Translate('qtfm_map.php');
  include 'qtfm_map_lib.php';
  if ( QTgcanmap('U') ) $bMap=true;
  if ( $bMap ) $oHtml->links[]='<link rel="stylesheet" type="text/css" href="qtfm_map.css" />';

  if ( isset($_GET['hidemap']) ) $_SESSION[QT]['m_map_hidelist']=true;
  if ( isset($_GET['showmap']) ) $_SESSION[QT]['m_map_hidelist']=false;
  if ( !isset($_SESSION[QT]['m_map_hidelist']) ) $_SESSION[QT]['m_map_hidelist']=false;
  if ( !isset($_SESSION[QT]['m_map_symbols']) ) $_SESSION[QT]['m_map_symbols']='0';
  $arrSymbolByRole = ( empty($_SESSION[QT]['m_map_symbols']) ? array() : QTexplode($_SESSION[QT]['m_map_symbols']) );
}

// COUNT

Switch ($strGroup)
{
Case 'all': $strWhere = ''; Break;
Case '#':   $strWhere = ' AND '.FirstCharCase('name','a-z'); Break;
Default:    $strWhere = ' AND '.FirstCharCase('name','u').'="'.$strGroup.'"'; Break;
}

$intTotal = $oVIP->SysCount('members');
if ($strGroup=='all')
{
$intCount = $intTotal;
}
else
{
$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE id>0'.$strWhere);
$row = $oDB->Getrow();
$intCount = $row['countid'];
}

// User menu

if ( $oVIP->user->IsStaff() ) include 'qtf_usermenu.php';

// GROUP LINE

if ( $intCount>$_SESSION[QT]['items_per_page'] || isset($_GET['group']) ) $strGroups = HtmlLettres($strGroup,$L['All']);

// --------
// HTML START
// --------

include 'qtf_p_header.php';

// --------
// Title and top 5
// --------

// header

echo '<table class="hidden">',PHP_EOL;
echo '<tr class="hidden">',PHP_EOL;
echo '<td class="hidden"><h2>',$oVIP->selfname,'</h2><p>',( $strGroup=='all' ? $intTotal.' '.$L['Members'] : $intCount.' / '.$intTotal.' '.$L['Members'] );
if ( CanPerform("show_calendar",$oVIP->user->role) )
{
echo '&nbsp;&middot;&nbsp;<a href="',Href('qtf_calendar.php'),(empty($row['birthday']) ? '' : '?m='.substr($row['birthday'],4,2)),'">',$L['Birthdays_calendar'],'</a>';
}
if ( !empty($strUsermenu) ) echo '&nbsp;&middot;&nbsp;',$strUsermenu;

echo '</p></td>',PHP_EOL;
echo '<td class="hidden" style="width:170px;">',PHP_EOL;
echo '<div class="infobox">',PHP_EOL;
echo '<h1>',$L['Top_participants'],'</h1>',PHP_EOL;
echo '<table class="hidden">',PHP_EOL;

//-- LIMIT QUERY --
$oDB->Query( LimitSQL('name, id, numpost FROM '.TABUSER.' WHERE id>0','numpost DESC',0,5) );
// --------

For ($i=0;$i<($_SESSION[QT]['viewmode']=='C' ? 2 : 5);$i++)
{
$row = $oDB->Getrow();
if (!$row) break;
echo '<tr><td style="text-align:left"><a href="qtf_user.php?id=',$row['id'],'">',$row['name'],'</a></td><td style="text-align:right">',$row['numpost'],'</td></tr>',PHP_EOL;
}
echo '</table>',PHP_EOL,'</div><br/>',PHP_EOL;
echo '</td>',PHP_EOL;
echo '</tr>',PHP_EOL;
echo '</table>',PHP_EOL;

// User form

if ( !empty($strUserform) ) echo $strUserform;

// --------
// Button line and pager
// --------

// -- build pager --

$strPager = MakePager("qtf_users.php?group=$strGroup&order=$strOrder&dir=$strDirec",$intCount,(int)$_SESSION[QT]['items_per_page'],$intPage);
if ( !empty($strPager) ) $strPager = $L['Page'].$strPager;
if ( $intCount<$intTotal ) $strPager = '<span class="small">'.$intCount.' '.$L['Selected_from'].' '.$intTotal.' '.strtolower($L['Users']).'</span>'.(empty($strPager) ? '' : ' | '.$strPager);

// -- Display button line (if more that tpp users) and pager --

if ($intTotal>$_SESSION[QT]['items_per_page']) echo '<table class="button"><tr class="button">',$strGroups,'</tr></table>',PHP_EOL;

if ( !empty($strPager) )
{
echo '<table class="hidden"><tr class="hidden"><td class="hidden" id="pager_zt">',$strPager,'</td></tr></table>',PHP_EOL,PHP_EOL;
}

// end if no result
if ($intCount==0)
{
  echo '<p>',$L['None'],'</p><br/>';
  include 'qtf_p_footer.php';
  exit;
}

// --------
// Memberlist
// --------

$bCompact = FALSE;
if ( $_SESSION[QT]['avatar']=='0' ||  $_SESSION[QT]['viewmode']=='C' ) $bCompact = true;

// === TABLE DEFINITION ===

$table = new cTable('t1','data_u',$intCount);
$table->activecol = 'user'.$strOrder;
$table->activelink = '<a  href="'.$oVIP->selfurl.'?group='.$strGroup.'&amp;order='.$strOrder.'&amp;dir='.($strDirec=='asc' ? 'desc' : 'asc').'&amp;page=1">%s</a> <img class="i_sort" src="'.$_SESSION[QT]['skin_dir'].'/sort_'.strtolower($strDirec).'.gif" alt="+"/>';
// column headers
if ( $bCompact )
{
$table->th['username'] = new cTableHead($L['Username'],'','','<a  href="'.$oVIP->selfurl.'?group='.$strGroup.'&amp;order=name&amp;dir=asc&amp;page=1">%s</a>'); $table->th['username']->Add('style','width:150px');
}
else
{
$table->th['userphoto'] = new cTableHead($L['Picture']); $table->th['userphoto']->Add('style','width:100px');
$table->th['username'] = new cTableHead($L['Username'],'','','<a  href="'.$oVIP->selfurl.'?group='.$strGroup.'&amp;order=name&amp;dir=asc&amp;page=1">%s</a>');
}
if ( $bMap ) { $table->th['usermarker'] = new cTableHead('&nbsp;'); $table->th['usermarker']->Add('style','width:15px'); }
$table->th['userrole'] = new cTableHead($L['Role'],'','','<a  href="'.$oVIP->selfurl.'?group='.$strGroup.'&amp;order=role&amp;dir=asc&amp;page=1">%s</a>');
$table->th['usercontact'] = new cTableHead($L['Contact']);
$table->th['userlocation'] = new cTableHead($L['Location'],'','','<a  href="'.$oVIP->selfurl.'?group='.$strGroup.'&amp;order=location&amp;dir=asc&amp;page=1">%s</a>');
$table->th['usernumpost'] = new cTableHead($L['Messages'],'','center','<a  href="'.$oVIP->selfurl.'?group='.$strGroup.'&amp;order=numpost&amp;dir=desc&amp;page=1">%s</a>');
// create column data (from headers identifiers) and add class to all
foreach($table->th as $key=>$th) { $table->th[$key]->Add('class','th'.$key); $table->td[$key] = new cTableData('','','td'.$key); }

// === TABLE START DISPLAY ===

echo PHP_EOL;
echo $table->Start().PHP_EOL;
echo '<thead>'.PHP_EOL;
echo $table->GetTHrow('','hidden').PHP_EOL;
echo '</thead>'.PHP_EOL;
echo '<tbody>'.PHP_EOL;

$oDB->Query( LimitSQL('* FROM '.TABUSER.' WHERE id>0'.$strWhere, $strOrder.' '.strtoupper($strDirec), $intLimit,$_SESSION[QT]['items_per_page'],$intCount) );

$intWhile=0;
$strAlt='r1';
while($row=$oDB->Getrow())
{
	// privacy control for map and location field
	if ( $oVIP->user->IsPrivate($row['privacy'],$row['id']) ) { $row['y']=null; $row['x']=null; }

	// prepare row
	$table->row = new cTableRow('','data_u '.$strAlt.' hover');

	// prepare values, and insert value into the cells
	$table->SetTDcontent( FormatTableRow('t1',$table->GetTHnames(),$row,null,$bMap), false ); // adding extra columns not allowed

	//show row content
	echo $table->GetTDrow().PHP_EOL;

	if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }

	// map settings
	if ( $bMap && !QTgempty($row['x']) && !QTgempty($row['y']) )
	{
		$y = (float)$row['y']; $x = (float)$row['x'];
		$strPname = QTconv($row['name'],'U');
		$strPinfo = $row['name'].'<br/><a class="gmap" href="'.Href('qtf_user.php').'?id='.$row['id'].'">Open profile &raquo;<\/a>';
		if ( !empty($row['picture']) ) $strPinfo = AsImg(QTF_DIR_PIC.$row['picture'],'',$row['name'],'markerprofileimage').$strPinfo;
		$oMapPoint = new cMapPoint($y,$x,$strPname,$strPinfo);
		if ( !empty($arrSymbolByRole[$row['role']]) ) $oMapPoint->icon = $arrSymbolByRole[$row['role']];
		$arrExtData[(int)$row['id']] = $oMapPoint;
	}

	$intWhile++;
	//odbcbreak
	if ( $intWhile>=$_SESSION[QT]['items_per_page'] ) break;
}

// === TABLE END DISPLAY ===

echo '</tbody>
</table>
';

// -- Display pager --

if ( !empty($strPager) )
{
echo '<table class="hidden"><tr class="hidden"><td class="hidden" id="pager_zb">',$strPager,'</td></tr></table>',PHP_EOL,PHP_EOL;
}

// MAP MODULE, Show map

if ( $bMap )
{
  echo '<!-- Map module -->',PHP_EOL;
  if ( count($arrExtData)==0 )
  {
    echo '<div class="gmap_disabled">'.$L['map']['E_noposition'].'</div>';
    $bMap=false;
  }
  else
  {
    //select zoomto (maximum 20 items in the list)
    $str = '';
    if ( count($arrExtData)>1 )
    {
      $str = '<p class="gmap commands" style="margin:0 0 4px 0"><a class="gmap" href="javascript:void(0)" onclick="zoomToFullExtend(); return false;">'.$L['map']['zoomtoall'].'</a> | '.L('Show').' <select class="gmap" id="zoomto" name="zoomto" size="1" onchange="gmapPan(this.value);">';
      $str .= '<option class="small_gmap" value="'.$_SESSION[QT]['m_map_gcenter'].'"> </option>';
      $i=0;
      foreach($arrExtData as $oMapPoint)
      {
      $str .= '<option class="small_gmap" value="'.$oMapPoint->y.','.$oMapPoint->x.'">'.$oMapPoint->title.'</option>';
      $i++; if ( $i>20 ) break;
      }
      $str .= '</select></p>'.PHP_EOL;
    }

    echo '<div class="gmap">',PHP_EOL;
    echo ($_SESSION[QT]['m_map_hidelist'] ? '' : $str.PHP_EOL.'<div id="map_canvas"></div>'.PHP_EOL);
    echo '<p class="gmap" style="margin:4px 0 0 0">',sprintf($L['map']['items'],strtolower( L('User',count($arrExtData))),strtolower(L('User',$intCount)) ),'</p>',PHP_EOL;
    echo '</div>',PHP_EOL;

    // Show/Hide

    if ( $_SESSION[QT]['m_map_hidelist'] )
    {
    echo '<div class="canvashandler"><a class="canvashandler" href="',Href(),'?showmap"><img class="canvashandler" src="qtfm_map_dw.gif" alt="+"/>',$L['map']['Show_map'],'</a></div>',PHP_EOL;
    }
    else
    {
    echo '<div class="canvashandler"><a class="canvashandler" href="',Href(),'?hidemap"><img class="canvashandler" src="qtfm_map_up.gif" alt="-"/>',$L['map']['Hide_map'],'</a></div>',PHP_EOL;
    }
  }
  echo '<!-- Map module end -->',PHP_EOL;
}

// --------
// HTML END
// --------

// MAP MODULE

if ( $bMap && !$_SESSION[QT]['m_map_hidelist'] )
{
  $gmap_shadow = false;
  $gmap_symbol = false;
  if ( !empty($_SESSION[QT]['m_map_gsymbol']) )
  {
    $arr = explode(' ',$_SESSION[QT]['m_map_gsymbol']);
    $gmap_symbol=$arr[0];
    if ( isset($arr[1]) ) $gmap_shadow=$arr[1];
  }

  // check new map center
  $y = floatval(QTgety($_SESSION[QT]['m_map_gcenter']));
  $x = floatval(QTgetx($_SESSION[QT]['m_map_gcenter']));

  // center on the first item
  foreach($arrExtData as $oMapPoint)
  {
    if ( !empty($oMapPoint->y) && !empty($oMapPoint->x) )
    {
    $y=$oMapPoint->y;
    $x=$oMapPoint->x;
    break;
    }
  }
  // update center
  $_SESSION[QT]['m_map_gcenter'] = $y.','.$x;

  $gmap_markers = array();
  $gmap_events = array();
  $gmap_functions = array();
  foreach($arrExtData as $oMapPoint)
  {
    if ( !empty($oMapPoint->y) && !empty($oMapPoint->x) )
    {
      $user_symbol = $gmap_symbol; // required to reset symbol on each user
      $user_shadow = $gmap_shadow;
      if ( !empty($oMapPoint->icon) ) $user_symbol = $oMapPoint->icon;
      if ( !empty($oMapPoint->shadow) ) $user_shadow = $oMapPoint->shadow;
      $gmap_markers[] = QTgmapMarker($oMapPoint->y.','.$oMapPoint->x,false,$user_symbol,$oMapPoint->title,$oMapPoint->info,$user_shadow);
    }
  }
  $gmap_functions[] = '
  function zoomToFullExtend()
  {
    if ( markers.length<2 ) return;
    var bounds = new google.maps.LatLngBounds();
    for (var i=markers.length-1; i>=0; i--) bounds.extend(markers[i].getPosition());
    map.fitBounds(bounds);
  }
  function showLocation(address)
  {
    if ( infowindow ) infowindow.close();
    geocoder.geocode( { "address": address}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK)
      {
        map.setCenter(results[0].geometry.location);
        if ( marker )
        {
          marker.setPosition(results[0].geometry.location);
        } else {
          marker = new google.maps.Marker({map: map, position: results[0].geometry.location, draggable: true, animation: google.maps.Animation.DROP, title: "Move to define the default map center"});
        }
      } else {
        alert("Geocode was not successful for the following reason: " + status);
      }
    });
  }

  ';
  include 'qtfm_map_load.php';
}

include 'qtf_p_footer.php';